<?php

namespace Teknisa\PED\Modules\Expedicao\Factories;

use \Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Teknisa\Libs\Util\DateUtil;

class exp0800ComissaoVendedorPeriodoFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        #initializes default service
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    public function getNotasFiscalVendedor($row) {
        
        $params = $this->getParamsApurar($row);
        $params['P_DTINIPERIODO']  = $row['INICIAL'];
        $params['P_DTFIMPERIODO']  = $row['FINAL'];
        unset($params['P_NRORG']);
        
        #defines function query
        $sql = "SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.NRNOTAFISC, NF.DTENTRSAID,
              NF.DTEMISSAO, NF.NREXPEDICAO, NF.CDSERIE, NF.VRNOTAFISC,
              NF.CDCLIENTE, CL.NRINSJURCLIE, CL.NMRAZSOCCLIE, CL.NMFANTCLIE,
              CL.IDTPIJURCLIE,
              'Sim'                                                                                                                                                                                                                                         AS IDPERIODO,
              SUM((IP.QTITEMPROD  * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(IM.VRIMPOSTOIT, 0)) - ROUND(NVL(((XE.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))                                                                            AS VRBASE,
              SUM(DECODE( PE.IDICMSCOMISS , 'S',
                (PE.VRPERCOMEXP  * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) + NVL(ST.VRIMPOSTOIT,0) - IP.VRDESCITEM - (NVL(IM.VRIMPOSTOIT, 0)) - ROUND(NVL(((XE.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100) / 100),
                (PE.VRPERCOMEXP  * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(IM.VRIMPOSTOIT, 0)) - ROUND(NVL(((XE.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100) / 100)))                      AS VRCOMISSAO ,
              SUM(PE.VRPERCOMEXP  * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) + NVL(ST.VRIMPOSTOIT,0) - IP.VRDESCITEM - (NVL(IM.VRIMPOSTOIT, 0)) - ROUND(NVL(((XE.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100) / 100) AS VRCOMISEXPST,
              SUM(PE.VRPERCOMEXP  * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(IM.VRIMPOSTOIT, 0)) - ROUND(NVL(((XE.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100) / 100)                         AS VRCOMISEXP  
            FROM 
                ITEMPRODUTO IP, VENDITEMPED VP, NOTAFISCAL NF,
              PAREXPEDICAO PE, CLIENTE CL, ITEMPROIMPOS IM,
              ITEMPEDIDO IPP,
              (SELECT I.CDFILIAL,
                I.NRLANCTONF,
                SUM(I.VRITEMENCA) AS VRITEMENCA
              FROM ITEMENCARGO I,
                ENCARGO E
              WHERE (I.CDFILIAL = :P_CDFILIAL)
              AND (I.CDENCARGO  = E.CDENCARGO)
              AND (I.VRITEMENCA > 0 )
              AND (E.IDENCARGO  = 'D' )
              GROUP BY I.CDFILIAL,
                I.NRLANCTONF
              ) XE,
              (SELECT SUM(IP.VRIMPOSTOIT) AS VRIMPOSTOIT,
                IP.CDFILIAL,
                IP.NRLANCTONF,
                IP.NRSEQITPROD
              FROM IMPOSTO I,
                IMPOSTONFE IM,
                ITEMPROIMPOS IP
              WHERE IM.CDIMPOSTONFE = '80'
              AND IM.CDIMPOSTONFE   = I.CDIMPOSTONFE
              AND I.CDIMPOSTO       = IP.CDIMPOSTO
              AND IP.CDFILIAL       = :P_CDFILIAL
                --AND IP.NRLANCTONF = :P_NRLANCTONF
              AND IP.CDFISCALIT = '1'
              GROUP BY IP.CDFILIAL,
                IP.NRLANCTONF,
                IP.NRSEQITPROD
              ) ST
            WHERE (IP.CDFILIAL              = VP.CDFILIAL )
            AND (IP.NRPEDIDO                = VP.NRPEDIDO )
            AND (IP.NRITEMPED               = VP.NRITEMPED )
            AND (IP.CDFILIAL                = IPP.CDFILIAL )
            AND (IP.NRPEDIDO                = IPP.NRPEDIDO )
            AND (IP.NRITEMPED               = IPP.NRITEMPED)
            AND (IP.CDFILIAL                = NF.CDFILIAL )
            AND (IP.NRLANCTONF              = NF.NRLANCTONF)
            AND (IP.CDFILIAL                = ST.CDFILIAL (+))
            AND (IP.NRLANCTONF              = ST.NRLANCTONF (+))
            AND (IP.NRSEQITPROD             = ST.NRSEQITPROD (+))
            AND (IP.CDFILIAL                = PE.CDFILIAL )
            AND (VP.CDVENDEDOR              = :P_CDVENDEDOR)
            AND (VP.CDFILIAL                = :P_CDFILIAL )
            AND (NVL(VP.IDCANCCOMISPED,'N') = 'N' )
            AND (NF.CDCLIENTE               = CL.CDCLIENTE )
            AND (NF.VRNOTAFISC              > 0 )
            AND ((NF.IDSTATUS              IN ('A','E'))
            OR (NF.IDSTATUSNFE              = 'A'))
            AND (IM.IDIMPDESONERAIT (+)     = 'S' )
            AND (NF.CDFILIAL                = XE.CDFILIAL (+))
            AND (NF.NRLANCTONF              = XE.NRLANCTONF (+))
            AND (IP.CDFILIAL                = IM.CDFILIAL (+))
            AND (IP.NRLANCTONF              = IM.NRLANCTONF (+))
            AND (IP.NRSEQITPROD             = IM.NRSEQITPROD (+))
            AND (NF.DTEMISSAO BETWEEN :P_DTINIPERIODO AND :P_DTFIMPERIODO)
            GROUP BY 
              NF.CDFILIAL, NF.NRLANCTONF, NF.NRNOTAFISC, NF.DTENTRSAID,
              NF.DTEMISSAO, NF.NREXPEDICAO, NF.CDSERIE, NF.VRNOTAFISC,
              NF.CDCLIENTE, CL.NRINSJURCLIE, CL.NMRAZSOCCLIE, 
              CL.NMFANTCLIE, CL.IDTPIJURCLIE, NF.CDVENDEDOR, VP.CDVENDEDOR
            ORDER BY 
              NF.CDFILIAL, NF.NRLANCTONF";

        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        #fetch all result rows and returns
        
        return $std->fetchAll();
        
    }
    
    public function getContasVendedor($row) {
        
        $params = $this->getParamsApurar($row);
        $params['P_DTINIPERIODO']  = $row['INICIAL'];
        $params['P_DTFIMPERIODO']  = $row['FINAL'];
        unset($params['P_NRORG']);
        
        #defines function query
        $sql = "SELECT CR.CDFILIAL, CR.NRLANCTONF, CR.NRSEQVENREC, CR.NRPARCELAREC, NF.NRNOTAFISC, BX.DTBAIXAREC AS DTLIQBOLREC,
                       NF.NREXPEDICAO, NF.CDSERIE, NF.VRNOTAFISC, CR.VRATUAREC, CR.DTATUAVENREC, NF.CDCLIENTE,
                       CL.NRINSJURCLIE, CL.NMRAZSOCCLIE, CL.NMFANTCLIE, CL.IDTPIJURCLIE, 'Sim' AS IDPERIODO,
                
                       SUM((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                       - ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) AS VRBASETOT,
                
                       SUM(VP.VRPECOMITPED * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                       - ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))/ 100) AS VRCOMISSAO,
                
                       SUM(VP.VRPECOMITPED * ((IP.QTITEMPROD * IP.VRUNITITEM) + NVL(ST.VRIMPOSTOIT,0) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                       - ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))/ 100) AS VRCOMISSAOST,
                
                       SUM(PE.VRPERCOMREC * (VP.VRPECOMITPED * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                       - ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100) / 100) AS VRCOMISTOT,
                
                       (
                        ((CR.VRATUAREC * 100) / XC.VRCONTA) *
                          SUM(ROUND(NVL(((NVL(EA.VRITEMENCA,1)*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100
                       ) AS VRRATEIAENC,
                
                       ((CR.VRATUAREC * 100) / XC.VRCONTA) AS VRPERPARCELA,
                
                       (
                        ((CR.VRATUAREC * 100) / XC.VRCONTA) *
                          SUM((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                          - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0))
                         / 100
                       ) VRBASE,
                
                       (
                        ((CR.VRATUAREC * 100) / XC.VRCONTA) *
                          SUM(PE.VRPERCOMREC * (VP.VRPECOMITPED * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                          - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0)) / 100) / 100)
                         / 100
                       ) VRCOMISREC,
                       
                       (
                        ((CR.VRATUAREC * 100) / XC.VRCONTA) *
                          SUM(PE.VRPERCOMREC * (VP.VRPECOMITPED * ((IP.QTITEMPROD * IP.VRUNITITEM) + NVL(ST.VRIMPOSTOIT,0) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                          - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0)) / 100) / 100)
                         / 100
                       ) VRCOMISRECST,
                
                       (CASE CR.DTATUAVENREC WHEN XC.DTATUAVENREC
                                             THEN NVL(EA.VRITEMENCA,0)
                                             ELSE 0
                                             END) AS VRENCACRESCE,
                
                       (CASE CR.DTATUAVENREC WHEN XC.DTATUAVENREC
                                             THEN (
                                                   (((CR.VRATUAREC - NVL(EA.VRITEMENCA,0)) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                     SUM((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                     - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0))
                                                    / 100
                                                  )
                                             ELSE (
                                                   (((CR.VRATUAREC) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                     SUM((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                     - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0))
                                                    / 100
                                                  )
                                             END) AS VRBASEENC,
                
                       (CASE CR.DTATUAVENREC WHEN XC.DTATUAVENREC
                                             THEN (
                                                   (((CR.VRATUAREC - NVL(EA.VRITEMENCA,0)) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                     SUM(PE.VRPERCOMREC * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                     - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0)) / 100) / 100)
                                                    / 100
                                                  )
                                             ELSE (
                                                   (((CR.VRATUAREC) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                     SUM(PE.VRPERCOMREC * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                     - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100)+ NVL(SA.SOMAAJUSTE,0)) / 100)
                                                    / 100
                                                  )
                                             END) AS VRCOMISENC,
                                             
                            (CASE CR.DTATUAVENREC WHEN XC.DTATUAVENREC
                                             THEN (
                                                   (((CR.VRATUAREC - NVL(EA.VRITEMENCA,0)) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                     SUM(PE.VRPERCOMREC * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) + NVL(ST.VRIMPOSTOIT,0) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                     - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0)) / 100) / 100)
                                                    / 100
                                                  )
                                             ELSE (
                                                   (((CR.VRATUAREC) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                     SUM(PE.VRPERCOMREC * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) + NVL(ST.VRIMPOSTOIT,0) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                     - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100)+ NVL(SA.SOMAAJUSTE,0)) / 100)
                                                    / 100
                                                  )
                                             END) AS VRCOMISENCST
                
                  FROM ITEMPRODUTO IP, VENDITEMPED VP, NOTAFISCAL NF, PAREXPEDICAO PE, CLIENTE CL,
                       CONTARECEBER CR, BOLETRECEBER BR, ITEMPROIMPOS XI, BAIXARECEBIDA BX,
                       ITEMPEDIDO IPP,
                       (
                        SELECT C.CDFILIAL, C.NRLANCTONF, SUM(C.VRATUAREC) AS VRCONTA, MIN(C.DTATUAVENREC) AS DTATUAVENREC
                          FROM CONTARECEBER C, NOTAFISCAL N
                         WHERE (C.CDFILIAL   = N.CDFILIAL)
                           AND (C.NRLANCTONF = N.NRLANCTONF)
                           AND (N.CDFILIEMIT = :P_CDFILIAL)
                           AND (C.VRATUAREC  > 0          )
                           AND (C.IDCONTAIMPOSTO = 'N'   )
                         GROUP BY C.CDFILIAL, C.NRLANCTONF
                       ) XC,
                       (
                        SELECT I.CDFILIAL, I.NRLANCTONF, SUM(I.VRITEMENCA) AS VRITEMENCA
                          FROM ITEMENCARGO I, ENCARGO E, NOTAFISCAL N
                         WHERE (I.CDFILIAL = N.CDFILIAL)
                           AND (I.NRLANCTONF = N.NRLANCTONF)
                           AND (N.CDFILIEMIT = :P_CDFILIAL)
                           AND (I.CDENCARGO  = E.CDENCARGO)
                           AND (I.VRITEMENCA > 0          )
                           AND (E.IDENCARGO  = 'D'        )
                         GROUP BY I.CDFILIAL, I.NRLANCTONF
                       ) ED,
                       (
                        SELECT I.CDFILIAL, I.NRLANCTONF, SUM(I.VRITEMENCA) AS VRITEMENCA
                          FROM ITEMENCARGO I, ENCARGO E, NOTAFISCAL N
                         WHERE (I.CDFILIAL = N.CDFILIAL)
                           AND (I.NRLANCTONF = N.NRLANCTONF)
                           AND (N.CDFILIEMIT   = :P_CDFILIAL)
                           AND (I.CDENCARGO  = E.CDENCARGO)
                           AND (I.VRITEMENCA > 0          )
                           AND (E.IDENCARGO  = 'A'        )
                         GROUP BY I.CDFILIAL, I.NRLANCTONF
                       ) EA,
                      (SELECT NVL(SUM(DECODE(T.IDAJUCTREC,'D',T.VRAJUSTEREC * -1, T.VRAJUSTEREC)),0) AS SOMAAJUSTE, T.NRLANCTONF, T.CDFILIAL, T.NRSEQVENREC, T.NRPARCELAREC
         FROM(SELECT T.IDAJUCTREC, A.VRAJUSTEREC, A.NRLANCTONF, A.CDFILIAL, A.NRSEQVENREC, A.NRPARCELAREC
                FROM NOTAFISCAL N
               INNER JOIN CONTARECEBER C
                  ON N.CDFILIAL   = C.CDFILIAL
                 AND N.NRLANCTONF = C.NRLANCTONF
               INNER JOIN AJCTRECEBER A
                  ON C.CDFILIAL     = A.CDFILIAL
                 AND C.NRLANCTONF   = A.NRLANCTONF
                 AND C.NRSEQVENREC  = A.NRSEQVENREC
                 AND C.NRPARCELAREC = A.NRPARCELAREC
               INNER JOIN TIPOAJRECEBER T
                  ON A.CDAJUCTREC = T.CDAJUCTREC
               WHERE N.CDFILIEMIT = :P_CDFILIAL
               UNION
              SELECT T.IDAJUCTREC, AJB.VRAJBOLREC, C.NRLANCTONF, C.CDFILIAL, C.NRSEQVENREC, C.NRPARCELAREC
                FROM NOTAFISCAL N
               INNER JOIN CONTARECEBER C
                  ON N.CDFILIAL   = C.CDFILIAL
                 AND N.NRLANCTONF = C.NRLANCTONF
              INNER JOIN BOLETRECEBER BO
                  ON C.CDFILIBOLREC = BO.CDFILIAL
                 AND C.NRLANBOLREC  = BO.NRLANBOLREC
               INNER JOIN AJBOLREC AJB
                  ON BO.CDFILIAL    = AJB.CDFILIAL
                 AND BO.NRLANBOLREC = AJB.NRLANBOLREC
               INNER JOIN TIPOAJRECEBER T
                  ON AJB.CDAJUCTREC = T.CDAJUCTREC
               WHERE N.CDFILIEMIT = :P_CDFILIAL)T
        GROUP BY T.NRLANCTONF, T.CDFILIAL, T.NRSEQVENREC, T.NRPARCELAREC) SA,
                
                      (SELECT SUM(IP.VRIMPOSTOIT) AS VRIMPOSTOIT,
                               IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD
                          FROM IMPOSTO I, IMPOSTONFE IM, ITEMPROIMPOS IP, NOTAFISCAL N
                           WHERE IM.CDIMPOSTONFE = '80'
                             AND IM.CDIMPOSTONFE = I.CDIMPOSTONFE
                             AND I.CDIMPOSTO = IP.CDIMPOSTO
                              AND IP.CDFILIAL = N.CDFILIAL
                              AND IP.NRLANCTONF = N.NRLANCTONF
                             AND  N.CDFILIEMIT = :P_CDFILIAL
                             AND IP.CDFISCALIT = '1'
                          GROUP BY IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD
                       ) ST
                
                 WHERE (IP.CDFILIAL     = VP.CDFILIAL    )
                   AND (IP.NRPEDIDO     = VP.NRPEDIDO    )
                   AND (IP.NRITEMPED    = VP.NRITEMPED   )
                   AND (IP.CDFILIAL     = IPP.CDFILIAL   )
                   AND (IP.NRPEDIDO     = IPP.NRPEDIDO   )
                   AND (IP.NRITEMPED    = IPP.NRITEMPED  )
                   AND (IP.CDFILIAL     = NF.CDFILIAL    )
                   AND (IP.NRLANCTONF   = NF.NRLANCTONF  )
                   AND (IP.CDFILIAL    = ST.CDFILIAL    (+))
                   AND (IP.NRLANCTONF  = ST.NRLANCTONF  (+))
                   AND (IP.NRSEQITPROD = ST.NRSEQITPROD (+))
                   AND (IP.CDFILIAL     = PE.CDFILIAL    )
                   AND (VP.CDVENDEDOR   = :P_CDVENDEDOR  )
                   AND (VP.CDFILIAL     = :P_CDFILIAL    )
                   AND (NVL(VP.IDCANCCOMISPED,'N') = 'N' )
                   AND (NF.CDCLIENTE    = CL.CDCLIENTE   )
                   AND (NF.CDFILIAL     = CR.CDFILIAL    )
                   AND (NF.NRLANCTONF   = CR.NRLANCTONF  )
                   AND (BR.CDFILIAL     = CR.CDFILIBOLREC)
                   AND (BR.NRLANBOLREC  = CR.NRLANBOLREC )
                   AND (BR.CDFILIBAIREC = BX.CDFILIAL    )
                   AND (BR.NRBAIXAREC   = BX.NRBAIXAREC  )
                   AND (CR.VRATUAREC           > 0       )
                   AND ((NF.IDSTATUS IN ('A','E')) OR (NF.IDSTATUSNFE = 'A'))
                   AND (BR.IDSTATBREC          = 'B'     )
                   AND (CR.IDCONTAIMPOSTO      = 'N'     )
                   AND (XI.IDIMPDESONERAIT (+) = 'S'     )
                   AND (NF.CDFILIAL     = XC.CDFILIAL    (+))
                   AND (NF.NRLANCTONF   = XC.NRLANCTONF  (+))
                   AND (NF.CDFILIAL     = ED.CDFILIAL    (+))
                   AND (NF.NRLANCTONF   = ED.NRLANCTONF  (+))
                   AND (NF.CDFILIAL     = EA.CDFILIAL    (+))
                   AND (NF.NRLANCTONF   = EA.NRLANCTONF  (+))
                   AND (IP.CDFILIAL     = XI.CDFILIAL    (+))
                   AND (IP.NRLANCTONF   = XI.NRLANCTONF  (+))
                   AND (IP.NRSEQITPROD  = XI.NRSEQITPROD (+))
                   AND (CR.CDFILIAL = SA.CDFILIAL(+))
                   AND (CR.NRLANCTONF = SA.NRLANCTONF(+))
                   AND (CR.NRSEQVENREC = SA.NRSEQVENREC(+))
                   AND (CR.NRPARCELAREC = SA.NRPARCELAREC(+))
                   AND (BX.DTBAIXAREC BETWEEN :P_DTINIPERIODO AND :P_DTFIMPERIODO)
                 GROUP BY CR.CDFILIAL, CR.NRLANCTONF, CR.NRSEQVENREC, CR.NRPARCELAREC, NF.NRNOTAFISC, BX.DTBAIXAREC,
                       NF.NREXPEDICAO, NF.CDSERIE, NF.VRNOTAFISC, CR.VRATUAREC, CR.DTATUAVENREC, NF.CDCLIENTE,
                       CL.NRINSJURCLIE, CL.NMRAZSOCCLIE, CL.NMFANTCLIE, CL.IDTPIJURCLIE, XC.VRCONTA, EA.VRITEMENCA, XC.DTATUAVENREC
                 ORDER BY CR.CDFILIAL, CR.NRLANCTONF, CR.NRSEQVENREC, CR.NRPARCELAREC, BX.DTBAIXAREC";

        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);

        #fetch all result rows and returns
       
        
        return $std->fetchAll();
    
        
        
    }
    
    public function getContasVendedorBaixaTot($row) {
        
        $params = $this->getParamsApurar($row);
        $params['P_DTINIPERIODO']  = $row['INICIAL'];
        $params['P_DTFIMPERIODO']  = $row['FINAL'];
        unset($params['P_NRORG']);
        
        #defines function query
        $sql = "SELECT NF.CDFILIAL, NF.NRLANCTONF, SUM(BUSCA_BASE_COMISSAO(IT.CDFILIAL,IT.NRLANCTONF, IT.NRSEQITPROD)) AS VRBASE,
       SUM(ROUND(BUSCA_BASE_COMISSAO(IT.CDFILIAL,IT.NRLANCTONF, IT.NRSEQITPROD) * ((DECODE(IP.VRDESCCOMISS , null, decode(C.VRDESCCOMISS, null, NVL(VE.VRPECOMITPED, 0), NVL(VE.VRPECOMITPED, 0) - C.VRDESCCOMISS),NVL(VE.VRPECOMITPED, 0))) /100)*(NVL(P.VRPERCOMREC,0)/100),2)) AS VRCOMISSAO
              FROM NOTAFISCAL NF, ITEMPRODUTO IT,  PEDIDO PE, CLIENTE C,  MODPGTO M, PRODUTO PR, VENDITEMPED VE, ITEMPEDIDO IP, VENDEDOR V, FILIAL F, PAREXPEDICAO P
             WHERE NF.CDFILIAL = IT.CDFILIAL
               AND NF.NRLANCTONF = IT.NRLANCTONF
               AND IT.CDFILIALPED = PE.CDFILIAL
               AND IT.NRPEDIDO = PE.NRPEDIDO
               AND PE.CDFILIAL = P.CDFILIAL
               AND NVL(VE.CDVENDEDOR,PE.CDVENDEDOR) = :P_CDVENDEDOR
               AND BUSCA_DATA_ULTIMA_BAIXA(NF.CDFILIAL, NF.NRLANCTONF) BETWEEN :P_DTINIPERIODO AND :P_DTFIMPERIODO
               AND NF.CDFILIEMIT = :P_CDFILIAL
              AND NF.CDCLIENTE = C.CDCLIENTE(+)
              AND PE.CDMODPGTO = M.CDMODPGTO
              AND IT.CDPRODUTO = PR.CDPRODUTO
              AND IT.CDFILIALPED = VE.CDFILIAL(+)
              AND IT.NRPEDIDO = VE.NRPEDIDO(+)
              AND IT.NRITEMPED = VE.NRITEMPED(+)
              AND IT.CDFILIALPED = IP.CDFILIAL
              AND IT.NRPEDIDO = IP.NRPEDIDO
              AND IT.NRITEMPED = IP.NRITEMPED
              AND PE.CDVENDEDOR = V.CDVENDEDOR
              AND NF.CDFILIEMIT = F.CDFILIAL
            GROUP BY NF.CDFILIAL, NF.NRLANCTONF";

        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);

        #fetch all result rows and returns
       
        
        return $std->fetchAll();
    
        
        
    }
    
    public function getValoresNota($row) {
        // Obtem os parametros da query
        $params = $this->getParamsApurar($row);
        // Adiciona um campo aos parametros
        $params['P_NRLANCTONF'] = $row['NRLANCTONF'];
        
        #defines function query
        $sql = "SELECT IP.QTITEMPROD, IP.VRUNITITEM, IP.VRDESCITEM, IM.VRIMPOSTOIT, XE.VRITEMENCA,
                        IP.VRTOTAITEM, NF.VRPRODUTOS, VP.VRPECOMITPED, IP.NRORG, PE.VRPERCOMEXP, IP.CDFILIAL
                 FROM ITEMPRODUTO IP, NOTAFISCAL NF, ITEMPROIMPOS IM, VENDITEMPED VP, PAREXPEDICAO PE,
                
                       (
                        SELECT I.CDFILIAL, I.NRLANCTONF, SUM(I.VRITEMENCA) AS VRITEMENCA
                          FROM ITEMENCARGO I, ENCARGO E
                         WHERE (I.CDFILIAL   = :P_CDFILIAL )
                           AND (I.CDENCARGO  = E.CDENCARGO)
                           AND (I.VRITEMENCA > 0  )
                           AND (E.IDENCARGO  = 'D' )
                         GROUP BY I.CDFILIAL, I.NRLANCTONF
                       ) XE  
                  
                 WHERE (IP.CDFILIAL    = VP.CDFILIAL  )
                   AND (IP.NRPEDIDO    = VP.NRPEDIDO  )
                   AND (IP.NRITEMPED   = VP.NRITEMPED )
                   AND (IP.CDFILIAL    = NF.CDFILIAL  )
                   AND (IP.NRLANCTONF  = :P_NRLANCTONF )
                   AND (IP.NRLANCTONF  = NF.NRLANCTONF)
                   AND (IP.CDFILIAL = PE.CDFILIAL)
                   AND (VP.CDVENDEDOR  = :P_CDVENDEDOR )
                   AND (VP.CDFILIAL    = :P_CDFILIAL  )
                   AND (NF.VRNOTAFISC     > 0         )
                   AND (NF.IDTIPOEMISNFE <> '0'       )
                   AND (IM.IDIMPDESONERAIT (+) = 'S'  )
                   AND (NF.CDFILIAL    = XE.CDFILIAL    (+))
                   AND (NF.NRLANCTONF  = XE.NRLANCTONF  (+))   
                   AND (IP.CDFILIAL    = IM.CDFILIAL    (+))
                   AND (IP.NRLANCTONF  = IM.NRLANCTONF  (+))
                   AND (IP.NRSEQITPROD = IM.NRSEQITPROD (+))
                   AND (IP.NRORG = :P_NRORG)
                   AND (IP.NRORG = NF.NRORG)";
                 
        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);

        #fetch all result rows and returns
        
        return $std->fetchAll();
    
        
        
    }
    
    public function ultParcelaConta($row) {
        /*$params = $this->getParamsApurar($row);
        
        $params['P_NRLANCTONF'] = $row['NRLANCTONF'];
        $params['P_CDFILIAL'] = $row['CDFILIAL'];*/

        $sql = "SELECT CR.NRSEQVENREC, CR.NRPARCELAREC, CR.VRATUAREC
              FROM NOTAFISCAL NF, CONTARECEBER CR
             WHERE NF.CDFILIAL =  :P_CDFILIAL
               AND NF.NRLANCTONF = :P_NRLANCTONF
               AND NF.CDFILIAL = CR.CDFILIAL
               AND NF.NRLANCTONF = CR.NRLANCTONF
               AND CR.DTATUAVENREC = (SELECT MAX(DTATUAVENREC)
                    FROM CONTARECEBER CR1
                   WHERE CR1.CDFILIAL = CR.CDFILIAL
                     AND CR1.NRLANCTONF = CR.NRLANCTONF)";
                            
        $params = array('P_CDFILIAL'		=> $row['CDFILIAL'],
						'P_NRLANCTONF'	    => $row['NRLANCTONF']
		);
         
        $std = $this->connection->prepare($sql);
        $std->execute($params);


        return $std->fetchAll();
    
        
        
    }
    
    public function getValoresContas($row) {
      
        $params = $this->getParamsApurar($row);
        // Adiciona um campo aos parametros
        
        $params['P_NRLANCTONF'] = $row['NRLANCTONF'];
        $params['P_NRSEQVENREC'] = $row['NRSEQVENREC'];
        
        $sql = "SELECT IP.QTITEMPROD, IP.VRUNITITEM, IP.VRDESCITEM, XI.VRIMPOSTOIT, ED.VRITEMENCA AS EDVRITEMENCA,
                IP.VRTOTAITEM, NF.VRPRODUTOS, VP.VRPECOMITPED, CR.VRATUAREC, XC.VRCONTA, PE.VRPERCOMREC,
                EA.VRITEMENCA AS EAVRITEMENCA, CR.DTATUAVENREC AS CRDTATUAVENREC , XC.DTATUAVENREC AS XCDTATUAVENREC
        FROM ITEMPRODUTO IP, VENDITEMPED VP, NOTAFISCAL NF, PAREXPEDICAO PE,  
               CONTARECEBER CR, BOLETRECEBER BR, ITEMPROIMPOS XI, BAIXARECEBIDA BX,
          
               (
                SELECT C.CDFILIAL, C.NRLANCTONF, C.NRORG, SUM(C.VRATUAREC) AS VRCONTA, MIN(C.DTATUAVENREC) AS DTATUAVENREC
                  FROM CONTARECEBER C
                 WHERE (C.CDFILIAL  = :P_CDFILIAL) 
                   AND (C.NRORG = :P_NRORG) 
                   AND (C.NRLANCTONF = :P_NRLANCTONF)   
                   AND (C.VRATUAREC > 0          )
                   AND (C.IDCONTAIMPOSTO = 'N'   )
                 GROUP BY C.CDFILIAL, C.NRLANCTONF, C.NRORG
               ) XC,
               (
                SELECT I.CDFILIAL, I.NRLANCTONF,I.NRORG, SUM(I.VRITEMENCA) AS VRITEMENCA
                  FROM ITEMENCARGO I, ENCARGO E
                 WHERE (I.CDFILIAL   = :P_CDFILIAL) 
                   AND (I.NRORG = :P_NRORG) 
                   AND (I.NRLANCTONF = :P_NRLANCTONF)
                   AND (I.CDENCARGO  = E.CDENCARGO)
                   AND (I.VRITEMENCA > 0          )
                   AND (E.IDENCARGO  = 'D'        )
                 GROUP BY I.CDFILIAL, I.NRLANCTONF, I.NRORG
               ) ED,
               (
                SELECT I.CDFILIAL, I.NRLANCTONF,I.NRORG, SUM(I.VRITEMENCA) AS VRITEMENCA
                  FROM ITEMENCARGO I, ENCARGO E
                 WHERE (I.CDFILIAL   = :P_CDFILIAL) 
                   AND (I.NRORG = :P_NRORG) 
                   AND (I.NRLANCTONF = :P_NRLANCTONF)
                   AND (I.CDENCARGO  = E.CDENCARGO)
                   AND (I.VRITEMENCA > 0          )
                   AND (E.IDENCARGO  = 'A'        )
                 GROUP BY I.CDFILIAL, I.NRLANCTONF, I.NRORG
               ) EA
               
         WHERE (IP.CDFILIAL     = VP.CDFILIAL    )
           AND (CR.NRSEQVENREC  = :P_NRSEQVENREC )
           AND (NF.NRLANCTONF   = :P_NRLANCTONF  )
           AND (NF.NRORG        = :P_NRORG       )
           AND (IP.NRPEDIDO     = VP.NRPEDIDO    )
           AND (IP.NRITEMPED    = VP.NRITEMPED   )
           AND (IP.CDFILIAL     = NF.CDFILIAL    )
           AND (IP.NRLANCTONF   = NF.NRLANCTONF  )
           AND (IP.CDFILIAL     = PE.CDFILIAL    )
           AND (VP.CDVENDEDOR   = :P_CDVENDEDOR  )
           AND (VP.CDFILIAL     = :P_CDFILIAL    )
           AND (NF.CDFILIAL     = CR.CDFILIAL    )
           AND (NF.NRLANCTONF   = CR.NRLANCTONF  )
           AND (BR.CDFILIAL     = CR.CDFILIBOLREC)
           AND (BR.NRLANBOLREC  = CR.NRLANBOLREC )
           AND (NF.NRORG        = CR.NRORG       (+))
           AND (BR.CDFILIBAIREC = BX.CDFILIAL    )
           AND (BR.NRBAIXAREC   = BX.NRBAIXAREC  )
           AND (NF.NRORG        = BX.NRORG       (+))
           AND (CR.VRATUAREC           > 0       )
           AND (NF.IDTIPOEMISNFE      <> '0'     )
           AND (BR.IDSTATBREC          = 'B'     )
           AND (CR.IDCONTAIMPOSTO      = 'N'     )
           AND (XI.IDIMPDESONERAIT (+) = 'S'     )
           AND (NF.CDFILIAL     = XC.CDFILIAL    (+))
           AND (NF.NRLANCTONF   = XC.NRLANCTONF  (+))
           AND (NF.NRORG        = XC.NRORG       (+))
           AND (NF.CDFILIAL     = ED.CDFILIAL    (+))
           AND (NF.NRLANCTONF   = ED.NRLANCTONF  (+))
           AND (NF.NRORG        = ED.NRORG       (+))
           AND (NF.CDFILIAL     = EA.CDFILIAL    (+))
           AND (NF.NRLANCTONF   = EA.NRLANCTONF  (+))
           AND (NF.NRORG        = EA.NRORG       (+))
           AND (IP.CDFILIAL     = XI.CDFILIAL    (+))
           AND (IP.NRLANCTONF   = XI.NRLANCTONF  (+))
           AND (IP.NRSEQITPROD  = XI.NRSEQITPROD (+))
           AND (IP.NRORG        = XI.NRORG       (+))
         ORDER BY CR.CDFILIAL, CR.NRLANCTONF, CR.NRSEQVENREC, CR.NRPARCELAREC, BX.DTBAIXAREC";
        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);

        #fetch all result rows and returns
       
        return $std->fetchAll();
        
    }
    
    public function deleteMapas($row) {
        
        $params = array(
                    "P_CDVENDEDOR"      => $row['VENDEDOR'],
                    "P_CDFILICOMIS"     => $row['CDFILIAL'],
                    "P_NRMAPACOMIS"     => $row['NRMAPACOMIS'],
                    "P_NRORG"           => $row['NRORG']
                );
        
        if($row['excluiForaPeriodo'] === 'S') { 
            $params['P_DTINIPERIODO'] = null;
            $params['P_DTFIMPERIODO'] = null;
        }
        else {
            $params['P_DTINIPERIODO'] = $row['INICIAL'];
            $params['P_DTFIMPERIODO'] = $row['FINAL'];
        }
        
        $this->deleteMapaExp($params);
        $this->deleteMapaRec($params);
        
    }
    
    public function getPoliticaFilial($row) {
        
        $params['P_CDFILIAL'] = $row['CDFILIAL'];

        #defines function query
        $sql = "SELECT FI.CDFILIAL, FI.NMFILIAL, FI.CDEMPRESA, FI.NRINSJURFILI, FI.CDEMPRESA, FI.CDINSCMUNI,
               FI.CDINSCESTA, PA.VRPERCOMEXP, PA.VRPERCOMREC, PP.IDENCARPRIPARC,
               (CASE PA.IDCOMISPERIODO WHEN 'S' THEN 'Sim'
                                       WHEN 'N' THEN 'Não'
                                       END) AS IDCOMISPERIODO
            FROM FILIAL FI, PAREXPEDICAO PA, PARAMPEDIDO PP
            WHERE ((FI.CDFILIAL = :P_CDFILIAL))
            AND (FI.CDFILIAL = PA.CDFILIAL (+))
            AND (FI.CDFILIAL = PP.CDFILIAL (+))
            ORDER BY FI.CDFILIAL, FI.NMFILIAL";

        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        #fetch all result rows and returns
        
        return $std->fetchAll();
 
    }
    
    public function getNotasForaPeriodo($row) {
        $params = array(
                    "P_CDVENDEDOR"      => $row['VENDEDOR'],
                    "P_CDFILIAL"        => $row['CDFILIAL'],
                    "P_CDFILICOMIS"     => $row['CDFILIAL'],
                    "P_NRMAPACOMIS"     => $row['NRMAPACOMIS'],
                    ":P_DTINIPERIODO"   => $row['INICIAL'],
                    ":P_DTFIMPERIODO"   => $row['FINAL']
                );
    
        #defines function query
        $sql = "SELECT X.CDFILIAL, X.NRLANCTONF, X.NRNOTAFISC, X.DTENTRSAID, X.DTEMISSAO,
                X.NREXPEDICAO, X.CDSERIE, X.VRNOTAFISC, X.CDCLIENTE, X.NRINSJURCLIE,
                X.NMRAZSOCCLIE, X.NMFANTCLIE, X.IDTPIJURCLIE, X.IDPERIODO,
                X.VRBASECOMIS, X.VRCOMISSAO, X.VRCOMISSAOST
                FROM (
                SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.NRNOTAFISC, NF.DTENTRSAID, NF.DTEMISSAO,
                NF.NREXPEDICAO, NF.CDSERIE, NF.VRNOTAFISC, NF.CDCLIENTE, CL.NRINSJURCLIE,
                CL.NMRAZSOCCLIE, CL.NMFANTCLIE, CL.IDTPIJURCLIE, 'Sim' AS IDPERIODO,
                
                SUM((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(IM.VRIMPOSTOIT, 0))
                - ROUND(NVL(((XE.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) AS VRBASECOMIS,
                
                SUM(PE.VRPERCOMEXP * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(IM.VRIMPOSTOIT, 0))
                - ROUND(NVL(((XE.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100) / 100) AS VRCOMISSAO,
                
                SUM(PE.VRPERCOMEXP * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) + NVL(ST.VRIMPOSTOIT,0) - IP.VRDESCITEM - (NVL(IM.VRIMPOSTOIT, 0))
                - ROUND(NVL(((XE.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100) / 100) AS VRCOMISSAOST
                FROM ITEMPRODUTO IP, VENDITEMPED VP, NOTAFISCAL NF, PAREXPEDICAO PE, CLIENTE CL, ITEMPROIMPOS IM,
                ITEMPEDIDO IPP,
                (
                SELECT I.CDFILIAL, I.NRLANCTONF, SUM(I.VRITEMENCA) AS VRITEMENCA
                FROM ITEMENCARGO I, ENCARGO E
                WHERE (I.CDFILIAL = :P_CDFILIAL)
                AND (I.CDENCARGO = E.CDENCARGO)
                AND (I.VRITEMENCA > 0 )
                AND (E.IDENCARGO = 'D' )
                GROUP BY I.CDFILIAL, I.NRLANCTONF
                ) XE,
                
                (
                SELECT SUM(IP.VRIMPOSTOIT) AS VRIMPOSTOIT,
                IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD
                FROM IMPOSTO I, IMPOSTONFE IM, ITEMPROIMPOS IP
                WHERE IM.CDIMPOSTONFE = '80'
                AND IM.CDIMPOSTONFE = I.CDIMPOSTONFE
                AND I.CDIMPOSTO = IP.CDIMPOSTO
                AND IP.CDFILIAL = :P_CDFILIAL
                --AND IP.NRLANCTONF = :P_NRLANCTONF
                AND IP.CDFISCALIT = '1'
                GROUP BY IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD
                ) ST
                
                WHERE (IP.CDFILIAL = VP.CDFILIAL )
                AND (IP.NRPEDIDO = VP.NRPEDIDO )
                AND (IP.NRITEMPED = VP.NRITEMPED )
                AND (IP.CDFILIAL = IPP.CDFILIAL )
                AND (IP.NRPEDIDO = IPP.NRPEDIDO )
                AND (IP.NRITEMPED = IPP.NRITEMPED)
                AND (IP.CDFILIAL = NF.CDFILIAL )
                AND (IP.NRLANCTONF = NF.NRLANCTONF)
                AND (IP.CDFILIAL = ST.CDFILIAL (+))
                AND (IP.NRLANCTONF = ST.NRLANCTONF (+))
                AND (IP.NRSEQITPROD = ST.NRSEQITPROD (+))
                AND (IP.CDFILIAL = PE.CDFILIAL )
                AND (VP.CDVENDEDOR = :P_CDVENDEDOR)
                AND (VP.CDFILIAL = :P_CDFILIAL )
                AND (NVL(VP.IDCANCCOMISPED,'N') = 'N' )
                AND (NF.CDCLIENTE = CL.CDCLIENTE )
                AND (NF.VRNOTAFISC > 0 )
                AND ((NF.IDSTATUS IN ('A','E')) OR (NF.IDSTATUSNFE = 'A'))
                AND (IM.IDIMPDESONERAIT (+) = 'S' )
                AND (NF.CDFILIAL = XE.CDFILIAL (+))
                AND (NF.NRLANCTONF = XE.NRLANCTONF (+))
                AND (IP.CDFILIAL = IM.CDFILIAL (+))
                AND (IP.NRLANCTONF = IM.NRLANCTONF (+))
                AND (IP.NRSEQITPROD = IM.NRSEQITPROD (+))
                AND (NF.DTEMISSAO BETWEEN :P_DTINIPERIODO AND :P_DTFIMPERIODO)
                GROUP BY NF.CDFILIAL, NF.NRLANCTONF, NF.NRNOTAFISC, NF.DTENTRSAID, NF.DTEMISSAO,
                NF.NREXPEDICAO, NF.CDSERIE, NF.VRNOTAFISC, NF.CDCLIENTE, CL.NRINSJURCLIE,
                CL.NMRAZSOCCLIE, CL.NMFANTCLIE, CL.IDTPIJURCLIE, NF.CDVENDEDOR, VP.CDVENDEDOR
                
                MINUS
                
                SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.NRNOTAFISC, NF.DTENTRSAID, NF.DTEMISSAO,
                NF.NREXPEDICAO, NF.CDSERIE, NF.VRNOTAFISC, NF.CDCLIENTE, CL.NRINSJURCLIE,
                CL.NMRAZSOCCLIE, CL.NMFANTCLIE, CL.IDTPIJURCLIE, 'Sim' AS IDPERIODO,
                ME.VRBASECOMIS, ME.VRCOMISSAO, ME.VRCOMISSAO
                FROM NOTAFISCAL NF, PAREXPEDICAO PE, CLIENTE CL, MAPACOMEXP ME
                WHERE (ME.CDFILICOMIS = PE.CDFILIAL )
                AND (ME.CDVENDEDOR = :P_CDVENDEDOR )
                AND (ME.CDFILICOMIS = :P_CDFILICOMIS)
                AND (ME.NRMAPACOMIS = :P_NRMAPACOMIS)
                AND (ME.CDFILIAL = NF.CDFILIAL )
                AND (ME.NRLANCTONF = NF.NRLANCTONF )
                AND (NF.CDCLIENTE = CL.CDCLIENTE )
                AND (NF.VRNOTAFISC > 0 )
                ) X
                ORDER BY X.IDPERIODO DESC, X.CDFILIAL, X.NRLANCTONF";
            
        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        #fetch all result rows and returns
        
        return $std->fetchAll();
    }
    
    public function getContasForaPeriodo($row) {
        //aqui 
         $params = array(
                    "P_CDVENDEDOR"      => $row['VENDEDOR'],
                    "P_CDFILIAL"        => $row['CDFILIAL'],
                    "P_CDFILICOMIS"     => $row['CDFILIAL'],
                    "P_NRMAPACOMIS"     => $row['NRMAPACOMIS'],
                    ":P_DTINIPERIODO"   => $row['INICIAL'],
                    ":P_DTFIMPERIODO"   => $row['FINAL']
                );
                
        $sql = "SELECT X.CDFILIAL, X.NRLANCTONF, X.NRSEQVENREC, X.NRPARCELAREC, X.NRNOTAFISC, X.DTLIQBOLREC,
                       X.NREXPEDICAO, X.CDSERIE, X.VRNOTAFISC, X.VRATUAREC, X.DTATUAVENREC, X.CDCLIENTE,
                       X.NRINSJURCLIE, X.NMRAZSOCCLIE, X.NMFANTCLIE, X.IDTPIJURCLIE, X.IDPERIODO,
                       X.VRBASECOMIS, X.VRCOMISSAO, X.NRNOTAFISC||'/'||X.CDSERIE AS DOCUMENTO,
                       X.VRRATEIAENC, X.VRENCACRESCE, X.VRBASEENC, X.VRCOMISENC, X.VRCOMISSAOST, X.VRCOMISENCST
                  FROM (
                        SELECT CR.CDFILIAL, CR.NRLANCTONF, CR.NRSEQVENREC, CR.NRPARCELAREC, NF.NRNOTAFISC, BX.DTBAIXAREC AS DTLIQBOLREC,
                               NF.NREXPEDICAO, NF.CDSERIE, NF.VRNOTAFISC, CR.VRATUAREC, CR.DTATUAVENREC, NF.CDCLIENTE,
                               CL.NRINSJURCLIE, CL.NMRAZSOCCLIE, CL.NMFANTCLIE, CL.IDTPIJURCLIE, 'Sim' AS IDPERIODO,
                               (
                                ((CR.VRATUAREC * 100) / XC.VRCONTA) *
                                  SUM((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                  - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0))
                                 / 100
                               ) VRBASECOMIS,
                               (
                                ((CR.VRATUAREC * 100) / XC.VRCONTA) *
                                  SUM(PE.VRPERCOMREC * (VP.VRPECOMITPED * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                  - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0)) / 100) / 100)
                                 / 100
                               ) VRCOMISSAO,
                
                               (
                                ((CR.VRATUAREC * 100) / XC.VRCONTA) *
                                  SUM(PE.VRPERCOMREC * (VP.VRPECOMITPED * ((IP.QTITEMPROD * IP.VRUNITITEM) + NVL(ST.VRIMPOSTOIT,0) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                  - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0)) / 100) / 100)
                                 / 100
                               ) VRCOMISSAOST,
                
                               (
                                ((CR.VRATUAREC * 100) / XC.VRCONTA) *
                                  SUM(ROUND(NVL(((NVL(EA.VRITEMENCA,0)*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2)) / 100
                               ) AS VRRATEIAENC,
                
                               (CASE CR.DTATUAVENREC WHEN XC.DTATUAVENREC
                                                    THEN NVL(EA.VRITEMENCA,0)
                                                    ELSE 0
                                                    END) AS VRENCACRESCE,
                
                               (CASE CR.DTATUAVENREC WHEN XC.DTATUAVENREC
                                                    THEN (
                                                          (((CR.VRATUAREC - NVL(EA.VRITEMENCA,0)) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                            SUM((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                            - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0))
                                                           / 100
                                                         )
                                                    ELSE (
                                                          (((CR.VRATUAREC) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                            SUM((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                            - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0))
                                                           / 100
                                                         )
                                                    END) AS VRBASEENC,
                
                               (CASE CR.DTATUAVENREC WHEN XC.DTATUAVENREC
                                                    THEN (
                                                          (((CR.VRATUAREC - NVL(EA.VRITEMENCA,0)) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                            SUM(PE.VRPERCOMREC * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                            - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0)) / 100) / 100)
                                                           / 100
                                                         )
                                                    ELSE (
                                                          (((CR.VRATUAREC) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                            SUM(PE.VRPERCOMREC * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                            - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0)) / 100) / 100)
                                                           / 100
                                                         )
                                                    END) AS VRCOMISENC,
                
                                (CASE CR.DTATUAVENREC WHEN XC.DTATUAVENREC
                                                    THEN (
                                                          (((CR.VRATUAREC - NVL(EA.VRITEMENCA,0)) * 100) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                            SUM(PE.VRPERCOMREC * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) + NVL(ST.VRIMPOSTOIT,0) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                            - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0)) / 100) / 100)
                                                           / 100
                                                         )
                                                    ELSE (
                                                          (((CR.VRATUAREC) ) / (XC.VRCONTA -  NVL(EA.VRITEMENCA,0))) *
                                                            SUM(PE.VRPERCOMREC * ((VP.VRPECOMITPED-NVL(IPP.VRDESCCOMISS,0)) * ((IP.QTITEMPROD * IP.VRUNITITEM) + NVL(ST.VRIMPOSTOIT,0) - IP.VRDESCITEM - (NVL(XI.VRIMPOSTOIT, 0))
                                                            - (ROUND(NVL(((ED.VRITEMENCA*(IP.VRTOTAITEM - IP.VRDESCITEM))/NF.VRPRODUTOS),0),2))+ NVL(SA.SOMAAJUSTE,0)) / 100) / 100)
                                                           / 100
                                                         )
                                                    END) AS VRCOMISENCST
                
                          FROM ITEMPRODUTO IP, VENDITEMPED VP, NOTAFISCAL NF, PAREXPEDICAO PE, CLIENTE CL,
                               CONTARECEBER CR, BOLETRECEBER BR, ITEMPROIMPOS XI, BAIXARECEBIDA BX,
                               ITEMPEDIDO IPP,
                               (
                                SELECT C.CDFILIAL, C.NRLANCTONF, SUM(C.VRATUAREC) AS VRCONTA, MIN(C.DTATUAVENREC) AS DTATUAVENREC
                                  FROM CONTARECEBER C
                                 WHERE (C.CDFILIAL  = :P_CDFILIAL)
                                   AND (C.VRATUAREC > 0          )
                                   AND (C.IDCONTAIMPOSTO = 'N'   )
                                 GROUP BY C.CDFILIAL, C.NRLANCTONF
                               ) XC,
                               (
                                SELECT I.CDFILIAL, I.NRLANCTONF, SUM(I.VRITEMENCA) AS VRITEMENCA
                                  FROM ITEMENCARGO I, ENCARGO E
                                 WHERE (I.CDFILIAL   = :P_CDFILIAL)
                                   AND (I.CDENCARGO  = E.CDENCARGO)
                                   AND (I.VRITEMENCA > 0          )
                                   AND (E.IDENCARGO  = 'D'        )
                                 GROUP BY I.CDFILIAL, I.NRLANCTONF
                               ) ED,
                               (
                                SELECT I.CDFILIAL, I.NRLANCTONF, SUM(I.VRITEMENCA) AS VRITEMENCA
                                  FROM ITEMENCARGO I, ENCARGO E
                                 WHERE (I.CDFILIAL   = :P_CDFILIAL)
                                   AND (I.CDENCARGO  = E.CDENCARGO)
                                   AND (I.VRITEMENCA > 0          )
                                   AND (E.IDENCARGO  = 'A'        )
                                 GROUP BY I.CDFILIAL, I.NRLANCTONF
                               ) EA,
                               (SELECT NVL(SUM(DECODE(T.IDAJUCTREC,'D',A.VRAJUSTEREC * -1, A.VRAJUSTEREC)),0) AS SOMAAJUSTE, A.NRLANCTONF, A.CDFILIAL, A.NRSEQVENREC, A.NRPARCELAREC
                                  FROM AJCTRECEBER A,
                                       TIPOAJRECEBER T
                                 WHERE A.CDFILIAL = :P_CDFILIAL
                                   AND A.CDAJUCTREC = T.CDAJUCTREC
                                 GROUP BY A.NRLANCTONF, A.CDFILIAL, A.NRSEQVENREC, A.NRPARCELAREC) SA,
                
                                (SELECT SUM(IP.VRIMPOSTOIT) AS VRIMPOSTOIT,
                                        IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD
                                   FROM IMPOSTO I, IMPOSTONFE IM, ITEMPROIMPOS IP
                                    WHERE IM.CDIMPOSTONFE = '80'
                                      AND IM.CDIMPOSTONFE = I.CDIMPOSTONFE
                                      AND I.CDIMPOSTO = IP.CDIMPOSTO
                                      AND IP.CDFILIAL = :P_CDFILIAL
                                      --AND IP.NRLANCTONF = :P_NRLANCTONF
                                      AND IP.CDFISCALIT = '1'
                                   GROUP BY IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD
                                ) ST
                
                         WHERE (IP.CDFILIAL     = VP.CDFILIAL    )
                           AND (IP.NRPEDIDO     = VP.NRPEDIDO    )
                           AND (IP.NRITEMPED    = VP.NRITEMPED   )
                           AND (IP.CDFILIAL     = IPP.CDFILIAL   )
                           AND (IP.NRPEDIDO     = IPP.NRPEDIDO   )
                           AND (IP.NRITEMPED    = IPP.NRITEMPED  )
                           AND (IP.CDFILIAL     = NF.CDFILIAL    )
                           AND (IP.NRLANCTONF   = NF.NRLANCTONF  )
                           AND (IP.CDFILIAL    = ST.CDFILIAL    (+))
                           AND (IP.NRLANCTONF  = ST.NRLANCTONF  (+))
                           AND (IP.NRSEQITPROD = ST.NRSEQITPROD (+))
                           AND (IP.CDFILIAL     = PE.CDFILIAL    )
                           AND (VP.CDVENDEDOR   = :P_CDVENDEDOR  )
                           AND (VP.CDFILIAL     = :P_CDFILIAL    )
                           AND (NVL(VP.IDCANCCOMISPED,'N') = 'N' )
                           AND (NF.CDCLIENTE    = CL.CDCLIENTE   )
                           AND (NF.CDFILIAL     = CR.CDFILIAL    )
                           AND (NF.NRLANCTONF   = CR.NRLANCTONF  )
                           AND (BR.CDFILIAL     = CR.CDFILIBOLREC)
                           AND (BR.NRLANBOLREC  = CR.NRLANBOLREC )
                           AND (BR.CDFILIBAIREC = BX.CDFILIAL    )
                           AND (BR.NRBAIXAREC   = BX.NRBAIXAREC  )
                           AND (CR.VRATUAREC           > 0       )
                           AND ((NF.IDSTATUS IN ('A','E')) OR (NF.IDSTATUSNFE = 'A'))
                           AND (BR.IDSTATBREC          = 'B'     )
                           AND (CR.IDCONTAIMPOSTO      = 'N'     )
                           AND (XI.IDIMPDESONERAIT (+) = 'S'     )
                           AND (NF.CDFILIAL     = XC.CDFILIAL    (+))
                           AND (NF.NRLANCTONF   = XC.NRLANCTONF  (+))
                           AND (NF.CDFILIAL     = ED.CDFILIAL    (+))
                           AND (NF.NRLANCTONF   = ED.NRLANCTONF  (+))
                           AND (NF.CDFILIAL     = EA.CDFILIAL    (+))
                           AND (NF.NRLANCTONF   = EA.NRLANCTONF  (+))
                           AND (IP.CDFILIAL     = XI.CDFILIAL    (+))
                           AND (IP.NRLANCTONF   = XI.NRLANCTONF  (+))
                           AND (IP.NRSEQITPROD  = XI.NRSEQITPROD (+))
                           AND (CR.CDFILIAL     = SA.CDFILIAL(+))
                           AND (CR.NRLANCTONF   = SA.NRLANCTONF(+))
                           AND (CR.NRSEQVENREC  = SA.NRSEQVENREC(+))
                           AND (CR.NRPARCELAREC = SA.NRPARCELAREC(+))
                           AND (BX.DTBAIXAREC BETWEEN :P_DTINIPERIODO AND :P_DTFIMPERIODO)
                         GROUP BY CR.CDFILIAL, CR.NRLANCTONF, CR.NRSEQVENREC, CR.NRPARCELAREC, NF.NRNOTAFISC, BX.DTBAIXAREC,
                               NF.NREXPEDICAO, NF.CDSERIE, NF.VRNOTAFISC, CR.VRATUAREC, CR.DTATUAVENREC, NF.CDCLIENTE,
                               CL.NRINSJURCLIE, CL.NMRAZSOCCLIE, CL.NMFANTCLIE, CL.IDTPIJURCLIE, XC.VRCONTA, EA.VRITEMENCA, XC.DTATUAVENREC
                
                           MINUS
                
                        SELECT CR.CDFILIAL, CR.NRLANCTONF, CR.NRSEQVENREC, CR.NRPARCELAREC, NF.NRNOTAFISC, BX.DTBAIXAREC AS DTLIQBOLREC,
                               NF.NREXPEDICAO, NF.CDSERIE, NF.VRNOTAFISC, CR.VRATUAREC, CR.DTATUAVENREC, NF.CDCLIENTE,
                               CL.NRINSJURCLIE, CL.NMRAZSOCCLIE, CL.NMFANTCLIE, CL.IDTPIJURCLIE, 'Sim' AS IDPERIODO,
                               MR.VRBASECOMIS, MR.VRCOMISSAO,  MR.VRCOMISSAO AS VRCOMISSAOST, MR.VRACRENCARGO AS VRRATEIAENC, MR.VRACRENCARGO AS VRENCACRESCE,
                               MR.VRBASECOMIS AS VRBASEENC, MR.VRCOMISSAO AS VRCOMISENC, MR.VRCOMISSAO AS VRCOMISENCST
                          FROM NOTAFISCAL NF, PAREXPEDICAO PE, CLIENTE CL, CONTARECEBER CR, MAPACOMREC MR, BOLETRECEBER BR, BAIXARECEBIDA BX
                         WHERE (MR.CDFILICOMIS  = PE.CDFILIAL    )
                           AND (MR.CDVENDEDOR   = :P_CDVENDEDOR  )
                           AND (MR.CDFILICOMIS  = :P_CDFILICOMIS )
                           AND (MR.NRMAPACOMIS  = :P_NRMAPACOMIS )
                           AND (MR.CDFILIAL     = NF.CDFILIAL    )
                           AND (MR.NRLANCTONF   = NF.NRLANCTONF  )
                           AND (MR.CDFILIAL     = CR.CDFILIAL    )
                           AND (MR.NRLANCTONF   = CR.NRLANCTONF  )
                           AND (MR.NRSEQVENREC  = CR.NRSEQVENREC )
                           AND (MR.NRPARCELAREC = CR.NRPARCELAREC)
                           AND (BR.CDFILIAL     = CR.CDFILIBOLREC)
                           AND (BR.NRLANBOLREC  = CR.NRLANBOLREC )
                           AND (BR.CDFILIBAIREC = BX.CDFILIAL    )
                           AND (BR.NRBAIXAREC   = BX.NRBAIXAREC  )
                           AND (NF.CDCLIENTE    = CL.CDCLIENTE   )
                           AND (NF.VRNOTAFISC   > 0              )
                       ) X
                 ORDER BY X.CDFILIAL, X.NRLANCTONF, X.NRSEQVENREC, X.NRPARCELAREC, X.DTLIQBOLREC
        ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        #fetch all result rows and returns
        return $std->fetchAll();
    }
    
    public function verificaNotaOutroPeriodo($row, $value) {
        $params = $this->getParamsApurar($row);
        $params['P_NRLANCTONF'] = $value['NRLANCTONF'];
       
        $sql = "SELECT * FROM MAPACOMEXP 
                WHERE CDVENDEDOR  = :P_CDVENDEDOR
                AND CDFILICOMIS = :P_CDFILIAL
                AND NRLANCTONF  = :P_NRLANCTONF
                AND NRORG       = :P_NRORG";
        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        #fetch all result rows and returns
        
        return $std->fetchAll();
    }
    
    public function verificaContaOutroPeriodo($row, $value) {
        // $params = $this->getParamsApurar($row);
        
        $params['P_CDVENDEDOR'] = $value['NRLANCTONF'];
        $params['P_CDFILIAL'] = $value['NRLANCTONF'];
        $params['P_NRLANCTONF'] = $value['NRLANCTONF'];
        $params['P_NRORG'] = $value['NRLANCTONF'];
      
        $sql = "SELECT * FROM MAPACOMREC 
                WHERE CDVENDEDOR  = :P_CDVENDEDOR
                AND CDFILICOMIS = :P_CDFILIAL
                AND NRLANCTONF  = :P_NRLANCTONF
                AND NRORG       = :P_NRORG";
        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        #fetch all result rows and returns
        
        return $std->fetchAll();
    }
    
    public function getMapasAnteriores($row) {
        $params = array();
        
        $params['P_CDVENDEDOR'] = $row['VENDEDOR'];
        $params['P_CDFILICOMIS'] = $row['CDFILIAL'];
        $params['P_NRMAPACOMIS'] = $row['NRMAPACOMIS'];
        
        $sql = "SELECT CDVENDEDOR, CDFILICOMIS, NRMAPACOMIS, DTINIPERIODO,
                    DTFIMPERIODO, NMMAPACOMIS, IDBLOQMAPACOMIS
                FROM (
                    SELECT CDVENDEDOR, CDFILICOMIS, NRMAPACOMIS, DTINIPERIODO,
                        DTFIMPERIODO, NMMAPACOMIS, IDBLOQMAPACOMIS
                    FROM MAPACOMPERIODO
                    WHERE (CDVENDEDOR = :P_CDVENDEDOR )
                    AND (CDFILICOMIS = :P_CDFILICOMIS)
                    AND (NRMAPACOMIS < :P_NRMAPACOMIS)
                    ORDER BY NRMAPACOMIS DESC
                )
                WHERE ROWNUM < 4
                ORDER BY NRMAPACOMIS";
                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        #fetch all result rows and returns
            
        return $std->fetchAll();
    }
    
    
    public function getProdutosNotaFiscal($row) {
        $params = array(
            "P_CDFILIAL"    => $row['CDFILIAL'],    
            "P_CDVENDEDOR"  => $row['CDVENDEDOR'],
            "P_NRLANCTONF"  => $row['NRLANCTONF']
        ); 
        
        $sql = "SELECT IP.CDFILIAL, IP.NRPEDIDO, IP.NRITEMPED, IP.NRSEQITPROD, VP.CDVENDEDOR, PR.CDPRODUTO,
                   PR.CDARVPROD, PR.NMPRODUTO, VP.VRPECOMITPED, SUM(IP.QTITEMPROD) AS QTITEMPROD, IP.VRUNITITEM,
                   XE.VRITEMENCA, IP.VRDESCITEM, IM.VRIMPOSTOIT, NF.VRPRODUTOS, IP.QTITEMPROD AS IPQTITEMPROD, IP.VRTOTAITEM      
              FROM ITEMPRODUTO IP, VENDITEMPED VP, PRODUTO PR, ITEMPROIMPOS IM, NOTAFISCAL NF,
                   (
                    SELECT I.CDFILIAL, I.NRLANCTONF, SUM(I.VRITEMENCA) AS VRITEMENCA
                      FROM ITEMENCARGO I, ENCARGO E
                     WHERE (I.CDFILIAL   = :P_CDFILIAL  )
                       AND (I.NRLANCTONF = :P_NRLANCTONF)
                       AND (I.CDENCARGO  = E.CDENCARGO  )
                       AND (I.VRITEMENCA > 0            )
                       AND (E.IDENCARGO  = 'D'          )
                     GROUP BY I.CDFILIAL, I.NRLANCTONF
                   ) XE
             WHERE (IP.CDFILIAL   = VP.CDFILIAL   (+))
               AND (IP.NRPEDIDO   = VP.NRPEDIDO   (+))
               AND (IP.NRITEMPED  = VP.NRITEMPED  (+))
               AND (:P_CDVENDEDOR = VP.CDVENDEDOR (+))
               AND (IP.CDFILIAL   = :P_CDFILIAL      )
               AND (IP.NRLANCTONF = :P_NRLANCTONF    )
               AND (IP.CDPRODUTO  = PR.CDPRODUTO     )
               AND (IP.CDFILIAL   = NF.CDFILIAL      )
               AND (IP.NRLANCTONF = NF.NRLANCTONF    )
               AND (IM.IDIMPDESONERAIT (+) = 'S'     )
               AND (NF.CDFILIAL    = XE.CDFILIAL    (+))
               AND (NF.NRLANCTONF  = XE.NRLANCTONF  (+))
               AND (IP.CDFILIAL    = IM.CDFILIAL    (+))
               AND (IP.NRLANCTONF  = IM.NRLANCTONF  (+))
               AND (IP.NRSEQITPROD = IM.NRSEQITPROD (+))
             GROUP BY IP.CDFILIAL, IP.NRPEDIDO, IP.NRITEMPED, IP.NRSEQITPROD, VP.CDVENDEDOR,
                      VP.VRPECOMITPED, PR.CDPRODUTO, PR.CDARVPROD, PR.NMPRODUTO, XE.VRITEMENCA,
                      IP.VRUNITITEM, IP.VRDESCITEM, IM.VRIMPOSTOIT, NF.VRPRODUTOS, IP.QTITEMPROD, IP.VRTOTAITEM
             ORDER BY IP.CDFILIAL, IP.NRPEDIDO, IP.NRITEMPED, IP.NRSEQITPROD";
        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function getVrComissao($row) {
        
        $params = array(
            "P_CDFILIAL"      => $row['CDFILIAL'],    
            "P_CDVENDEDOR"    => $row['VENDEDOR'],
            "P_DTINIPERIODO"  => $row['INICIAL'],
            "P_DTFIMPERIODO"  => $row['FINAL']
        ); 
        
        #defines function query
        $sql = "SELECT NF.CDFILIAL, NF.NRLANCTONF, SUM(BUSCA_BASE_COMISSAO(IT.CDFILIAL,IT.NRLANCTONF, IT.NRSEQITPROD)) AS VRBASECOMIS,
                   SUM(ROUND(BUSCA_BASE_COMISSAO(IT.CDFILIAL,IT.NRLANCTONF, IT.NRSEQITPROD) * ((DECODE(IP.VRDESCCOMISS , null, decode(C.VRDESCCOMISS, null, NVL(VE.VRPECOMITPED, 0), NVL(VE.VRPECOMITPED, 0) - C.VRDESCCOMISS),NVL(VE.VRPECOMITPED, 0))) /100)*(NVL(P.VRPERCOMREC,0)/100),2)) AS VRCOMISSAO
              FROM NOTAFISCAL NF, ITEMPRODUTO IT,  PEDIDO PE, CLIENTE C,  MODPGTO M, PRODUTO PR, VENDITEMPED VE, ITEMPEDIDO IP, VENDEDOR V, FILIAL F, PAREXPEDICAO P
             WHERE NF.CDFILIAL = IT.CDFILIAL
               AND NF.NRLANCTONF = IT.NRLANCTONF
               AND IT.CDFILIALPED = PE.CDFILIAL
               AND IT.NRPEDIDO = PE.NRPEDIDO
               AND PE.CDFILIAL = P.CDFILIAL
               AND NVL(VE.CDVENDEDOR,PE.CDVENDEDOR) = :P_CDVENDEDOR
               AND BUSCA_DATA_ULTIMA_BAIXA(NF.CDFILIAL, NF.NRLANCTONF) BETWEEN :P_DTINIPERIODO AND :P_DTFIMPERIODO
               AND NF.CDFILIEMIT = :P_CDFILIAL
              AND NF.CDCLIENTE = C.CDCLIENTE(+)
              AND PE.CDMODPGTO = M.CDMODPGTO
              AND IT.CDPRODUTO = PR.CDPRODUTO
              AND IT.CDFILIALPED = VE.CDFILIAL(+)
              AND IT.NRPEDIDO = VE.NRPEDIDO(+)
              AND IT.NRITEMPED = VE.NRITEMPED(+)
              AND IT.CDFILIALPED = IP.CDFILIAL
              AND IT.NRPEDIDO = IP.NRPEDIDO
              AND IT.NRITEMPED = IP.NRITEMPED
              AND PE.CDVENDEDOR = V.CDVENDEDOR
              AND NF.CDFILIEMIT = F.CDFILIAL
            GROUP BY NF.CDFILIAL, NF.NRLANCTONF";

        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        #fetch all result rows and returns
        
        return $std->fetchAll();
        
    }
    
    
    public function getProdutosComissao($row) {
        $params = array(
            "P_CDFILIAL"    => $row['CDFILIAL'],    
            "P_CDVENDEDOR"  => $row['CDVENDEDOR'],
            "P_NRLANCTONF"  => $row['NRLANCTONF']
        ); 
        
        $sql = "SELECT VP.CDFILIAL, IP.NRPEDIDO, IP.NRITEMPED, IP.CDPRODUTO,
               SUM(IP.QTITEMPROD) AS QTITEMPROD,
               IP.VRUNITITEM,
               SUM(IP.VRUNITITEM) AS VRUNITITEM,
               ROUND(SUM(IP.VRUNITITEM - (IP.VRDESCITEM/IP.QTITEMPROD)),2) AS VRUNITDESCITEM,
               SUM(IP.VRDESCITEM) AS VRDESCITEM,
               VP.CDVENDEDOR, (VP.VRPECOMITPED-NVL(I.VRDESCCOMISS,0)) AS VRPECOMITPED
          FROM ITEMPRODUTO IP, VENDITEMPED VP, ITEMPEDIDO I
         WHERE (IP.CDFILIALPED = VP.CDFILIAL   (+))
           AND (IP.NRPEDIDO    = VP.NRPEDIDO   (+))
           AND (IP.NRITEMPED   = VP.NRITEMPED  (+))
           AND (IP.CDFILIAL    = I.CDFILIAL    (+))
           AND (IP.NRPEDIDO    = I.NRPEDIDO    (+))
           AND (IP.NRITEMPED   = I.NRITEMPED   (+))
           AND (:P_CDVENDEDOR  = VP.CDVENDEDOR (+))
           AND (NVL(VP.IDCANCCOMISPED,'N') = 'N' )
           AND (IP.CDFILIAL   = :P_CDFILIAL      )
           AND (IP.NRLANCTONF = :P_NRLANCTONF    )
         GROUP BY VP.CDFILIAL, IP.NRPEDIDO, IP.NRITEMPED, IP.CDPRODUTO, VP.CDVENDEDOR, (VP.VRPECOMITPED-NVL(I.VRDESCCOMISS,0)), IP.VRUNITITEM
         ORDER BY VP.CDFILIAL, IP.NRPEDIDO, IP.NRITEMPED, IP.VRUNITITEM";
        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }

    public function verificaAlertaMapas($row) {
        $params = array();
        $params['P_CDFILICOMIS']    = $row['CDFILIAL'];
        $params['P_CDVENDEDOR']    = $row['VENDEDOR'];
        $params['P_NRORG']         = $row['NRORG'];
        $params['P_NRMAPACOMIS']   = $row['NRMAPACOMIS'];
        $sql = "SELECT * FROM MAPACOMEXP WHERE CDFILICOMIS = :P_CDFILICOMIS AND CDVENDEDOR = :P_CDVENDEDOR
            AND NRORG = :P_NRORG AND NRMAPACOMIS = :P_NRMAPACOMIS AND DSERROMAPAEXP IS NOT NULL";
            
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        if($std->fetchAll()) return true;
        
        else {
            $sql = "SELECT * FROM MAPACOMREC WHERE CDFILICOMIS = :P_CDFILICOMIS AND CDVENDEDOR = :P_CDVENDEDOR
            AND NRORG = :P_NRORG AND NRMAPACOMIS = :P_NRMAPACOMIS AND DSERROMAPAREC IS NOT NULL";
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
            if($std->fetchAll()) return true;
            else return false;
        }
        
        
    }
    
    public function verificaCDTPCTPAGAR($row){

        try{
            $sql = "SELECT MAX(CDTPCTPAGAR) AS CDTPCTPAGAR 
                      FROM FORNECEDOR
                        WHERE CDFORNECED = :P_CDFORNECED";
            $params = array();
            $params['P_CDFORNECED']    = $row['CDFORNECED'];
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
            return $std->fetchAll();
            
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function gerarContaPagar($row) {
        try{
            $procedure = new StoredProcedure($this->connection, 'GRAVA_CONTA_COMISSAO');
            $procedure->addParam(new Param('P_CDFILIAL',       Param::PARAM_INPUT,  $row['CDFILIAL'    ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDEMPRESA',      Param::PARAM_INPUT,  $row['CDEMPRESA'   ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRCONTAPAG',     Param::PARAM_INPUT,  $row['VRCONTAPAG'  ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTCONTAPAG',     Param::PARAM_INPUT,  $row['DTCONTAPAG'  ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFORNECED',     Param::PARAM_INPUT,  $row['CDFORNECED'  ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRNOTAFISC',     Param::PARAM_INPUT,  $row['NRNOTAFISC'  ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF',     Param::PARAM_INPUT,  $row['NRLANCTONF'  ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANBOLPAG',    Param::PARAM_INPUT,  $row['NRLANBOLPAG' ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILIRECE',     Param::PARAM_INPUT,  $row['CDFILIAL'    ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDVENDEDOR',     Param::PARAM_INPUT,  $row['VENDEDOR'    ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSCONTAPAG',     Param::PARAM_INPUT,  $row['DSCONTAPAG'  ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRPARCPGTOFO',   Param::PARAM_INPUT,  $row['NRPARCPGTOFO']    , Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_VRCONTAPARC',    Param::PARAM_INPUT,  $row['VRCONTAPARC' ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSERIE',        Param::PARAM_INPUT,  $row['CDSERIE'     ]    , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRSEQVENPAG',    Param::PARAM_INPUT,  $row['NRSEQVENPAG' ]    , Param::PARAM_TYPE_STR));
            //$procedure->addParam(new Param('P_CDOPERACTPG',    Param::PARAM_INPUT,  $row['CDOPERACTPG']     , Param::PARAM_TYPE_STR));
            //$procedure->addParam(new Param('P_DTLIBERACAOFIN', Param::PARAM_INPUT,  $row['DTLIBERACAOFIN' ] , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_GERA_ERRO',      Param::PARAM_OUTPUT, ''                      , Param::PARAM_TYPE_STR, 1));
            $procedure->addParam(new Param('P_CDTPCTPAGAR',    Param::PARAM_OUTPUT, ''                      , Param::PARAM_TYPE_STR, 6));

            return $procedure->execute();
            
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getContasPagar($row){
        $params = array(
            "P_CDFILIAL"   => $row['CDFILIAL'],
            "P_NRLANCTONF" => $row['NRLANCTONF']
        );
        $sql = "SELECT 
                  CDFILIAL, NRLANCTONF, NRSEQVENPAG,
                  NRPARCELAPAG, CDEMPRESA
                FROM 
                  CONTAPAGAR
                WHERE (CDFILIAL = :P_CDFILIAL)
                  AND (NRLANCTONF = :P_NRLANCTONF)
                ORDER BY 
                  CDFILIAL, NRLANCTONF,
                  NRSEQVENPAG, NRPARCELAPAG";
            
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        #fetch all result rows and returns
        return $std->fetchAll();
    }
    
    public function getFornecedor($row) {
        $params = array(
            "P_CDVENDEDOR" => $row['VENDEDOR'],
            "P_NRORG"      => $row['NRORG']
        );
        
        $sql =  "SELECT FO.CDFORNECED, FO.IDTPIJURFORN, FO.NRINSJURFORN,
           FO.NMRAZSOCFORN, FO.NMFANTFORN, FO.CDTPCTPAGAR,
           FO.NRPARCPGTOFO, FO.IDTPFORPGTFO
           FROM VENDEDOR VE, FORNECEDOR FO
           WHERE (VE.CDFORNECED = FO.CDFORNECED)
           AND (VE.CDVENDEDOR = :P_CDVENDEDOR)
           AND (VE.NRORG      = :P_NRORG)";
            
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getDadosFilial($row) {
        $params = array(
            "P_CDFILIAL" => $row['CDFILIAL'],
            "P_NRORG"    => $row['NRORG']
        );
        
        $sql =  "SELECT CDSERIE, CDEMPRESA
                  FROM FILIAL
                 WHERE (CDFILIAL = :P_CDFILIAL)
                 AND (NRORG = :P_NRORG)";
            
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }

    public function verificaCodigoNota($row) {
        $params = array("P_NRNOTAFISC" => $row['NRNOTAFISC'],
                        "P_CDFILIAL"   => $row['CDFILIAL'  ],
                        "P_NRORG"      => $row['NRORG'     ]);
        
        $sql = "SELECT * FROM NOTAFISCAL 
                WHERE (NRNOTAFISC LIKE :P_NRNOTAFISC  )
                      AND (CDFILIAL     =  :P_CDFILIAL)
                      AND (NRORG        =  :P_NRORG   )";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function getContasNota($row) {
        $params = array("P_NRLANCTONF" => $row['NRLANCTONF'],
                        "P_CDFILIAL"   => $row['CDFILIAL'  ],
                        "P_NRORG"      => $row['NRORG'     ]);
        
        $sql = "SELECT * FROM CONTARECEBER 
                WHERE (NRLANCTONF       =  :P_NRLANCTONF  )
                      AND (CDFILIAL     =  :P_CDFILIAL    )
                      AND (NRORG        =  :P_NRORG       )";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll(); 
    }
    
    public function getNotaVendItem($row) {
        $params = array(":P_NRPEDIDO"    => $row['NRPEDIDO'   ],
                        ":P_CDFILIAL"    => $row['CDFILIAL'   ],
                        ":P_CDVENDEDOR"  => $row['CDVENDEDOR' ]);
                        
        $sql = "SELECT NRLANCTONF FROM VENDITEMPED VP, ITEMPRODUTO IP 
                         WHERE  (VP.NRPEDIDO    = :P_NRPEDIDO  )
                                   AND (VP.CDFILIAL    = :P_CDFILIAL  )
                                   AND (VP.CDVENDEDOR  = :P_CDVENDEDOR)
                                   AND (IP.CDFILIAL    = VP.CDFILIAL  )
                                   AND (IP.NRPEDIDO    = VP.NRPEDIDO  )
                                   AND (IP.NRITEMPED   = VP.NRITEMPED )";
        $std = $this->connection->prepare($sql);
        $std->execute($params);         
        
        return $std->fetchAll();
    }
    
    public function verificaContaPagarMapa($row) {
        $params = array("P_NRLANCTONF"  => $row['NRLANCTONF' ],
                        "P_NRMAPACOMIS" => $row['NRMAPACOMIS'],
                        "P_CDFILIAL"    => $row['CDFILIAL'   ],
                        "P_CDVENDEDOR"  => $row['CDVENDEDOR' ]);
        $sql = "SELECT MP.* FROM MAPACOMPAG MP,
                    (SELECT NRMAPACOMIS, CDVENDEDOR, CDFILICOMIS FROM MAPACOMEXP ME
                    WHERE (ME.NRLANCTONF  = :P_NRLANCTONF ) 
                      AND (ME.CDVENDEDOR     = :P_CDVENDEDOR)
                      AND (ME.CDFILICOMIS    = :P_CDFILIAL  )
                    UNION 
                    SELECT NRMAPACOMIS, CDVENDEDOR, CDFILICOMIS FROM MAPACOMREC MR
                    WHERE (MR.NRLANCTONF  = :P_NRLANCTONF  )
                      AND (MR.CDVENDEDOR  = :P_CDVENDEDOR  )
                      AND (MR.CDFILICOMIS = :P_CDFILIAL    ))C
                WHERE   (MP.NRMAPACOMIS <> :P_NRMAPACOMIS  )
                    AND (MP.CDVENDEDOR     = :P_CDVENDEDOR )
                    AND (MP.CDFILICOMIS    = :P_CDFILIAL   )
                    AND (MP.CDVENDEDOR     =  C.CDVENDEDOR )
                    AND (MP.CDFILICOMIS    =  C.CDFILICOMIS)
                    AND (MP.NRMAPACOMIS    = C.NRMAPACOMIS )";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);         
        
        return $std->fetchAll();
    }
    
    public function getNRMAPACOMEXP($row) {
         $params = array(":P_NRLANCTONF"  => $row['NRLANCTONF'  ],
                        ":P_CDFILIAL"     => $row['CDFILICOMIS' ],
                        ":P_CDVENDEDOR"   => $row['CDVENDEDOR'  ]);
                        
        $sql = "SELECT NRMAPACOMEXP, NRMAPACOMIS FROM MAPACOMEXP
                         WHERE  (CDVENDEDOR  = :P_CDVENDEDOR)
                            AND (CDFILICOMIS = :P_CDFILIAL  )
                            AND (NRLANCTONF  = :P_NRLANCTONF)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);         
        
        return $std->fetchAll();
    
    }
    
    public function getNRMAPACOMREC($row) {

        $params = array(":P_NRLANCTONF"  => $row['NRLANCTONF'  ],
                        ":P_CDFILIAL"     => $row['CDFILICOMIS' ],
                        ":P_NRSEQVENREC"  => $row['NRSEQVENREC' ],
                        ":P_CDVENDEDOR"   => $row['CDVENDEDOR'  ]);
                        
        $sql = "SELECT NRMAPACOMREC, NRMAPACOMIS FROM MAPACOMREC
                         WHERE  (CDVENDEDOR  = :P_CDVENDEDOR )
                            AND (CDFILICOMIS = :P_CDFILIAL   )
                            AND (NRSEQVENREC = :P_NRSEQVENREC)
                            AND (NRLANCTONF  = :P_NRLANCTONF )";
        $std = $this->connection->prepare($sql);
        $std->execute($params);         
        
        return $std->fetchAll();
    }
    
    public function procedureRecalculoComissao($row){
        $this->connection->beginTransaction();
        $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_COMISSAOVEND'); //('GERA_COMISSAOVEND')
        $procedure->addParam(new Param('P_CDFILIAL'    , Param::PARAM_INPUT, $row['CDFILIAL']        , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRPEDIDO'    , Param::PARAM_INPUT, $row['NRPEDIDO']        , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDVENDEDOR'  , Param::PARAM_INPUT, $row['CDVENDEDOR']      , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR'  , Param::PARAM_INPUT, $row['CDOPELANPED']     , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRITEMPED'   , Param::PARAM_INPUT, NULL                    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDSITITEMPED', Param::PARAM_INPUT, NULL                    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODUTO'   , Param::PARAM_INPUT, NULL                    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VRPREUNITPED', Param::PARAM_INPUT, NULL                    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_OLDCDVENDE'  , Param::PARAM_INPUT, NULL                    , Param::PARAM_TYPE_STR));
        $procedure->execute(); //Invoca a procedure para gerar comissão
        $this->connection->commit();
    }
    
    public function recalculoComissao($rows){
        
        foreach ($rows as $row){
            $retornoSelect = $this->retornaDadosComissao($row);
            foreach($retornoSelect as $row){
                try {
                    $this->procedureRecalculoComissao($row);
                    
                } catch (\Exception $e) {
                    $this->entityManager->rollback();
                    throw $e;
                }    
            }
        }
        
        
    }
    
    public function retornaDadosComissao($row) {
        
        $sql = "SELECT CDFILIAL,
                       NRPEDIDO,
                       IDSITPEDIDO,
                       CDVENDEDOR,
                       CDOPELANPED,
                       NRITEMPED,
                       CDPRODUTO,
                       VRPREUNITPED,
                       IDSITITEMPED FROM
                       (SELECT P.CDFILIAL, P.NRPEDIDO, V.NRPEDIDO NRPEDIDO_VEN, P.IDSITPEDIDO, P.CDVENDEDOR, P.CDOPELANPED,
                               I.NRITEMPED, I.CDPRODUTO, I.VRPREUNITPED, I.IDSITITEMPED
                               FROM PEDIDO P, ITEMPEDIDO I, VENDITEMPED V
                               WHERE P.CDFILIAL = :P_CDFILIAL
                               AND P.CDVENDEDOR = :P_CDVENDEDOR
                               AND P.DTPEDIDO BETWEEN :P_DATAINICIAL AND :P_DATAFINAL
                               AND P.NRPEDIDO = I.NRPEDIDO
                               AND P.NRPEDIDO = V.NRPEDIDO(+)
                               ORDER BY P.NRPEDIDO, I.NRITEMPED)
                               WHERE NRPEDIDO_VEN IS NULL";
        try {
            $params = array(
                ':P_CDFILIAL' => $row['CDFILIAL'],
                ':P_CDVENDEDOR' => $row['CDVENDEDOR'],
                ':P_DATAINICIAL' => $row['DATAINICIAL'],
                ':P_DATAFINAL' => $row['DATAFINAL'],
            );

            $std = $this->connection->prepare($sql);
            $std->execute($params);      
            return $std->fetchAll();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    //-----------------------------------------------------------------------------//
    
    protected function getParamsApurar($row) {
        // Retorna os parametros necessarios para query

        $params                    = array();
        $params['P_CDFILIAL']      = $row['CDFILIAL'];
        $params['P_CDVENDEDOR']    = $row['VENDEDOR'];
        $params['P_NRORG']         = $row['NRORG'];
        
        return $params;
        
    }
    
    public function getParexpedicao($value) {
        $params = array(":P_CDFILIAL"     => $value['CDFILICOMIS' ]);
                        
        $sql = "SELECT
                    * 
                FROM 
                    PAREXPEDICAO 
                WHERE  (CDFILIAL = :P_CDFILIAL)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);         
        
        return $std->fetchAll();
    }
    
    protected function deleteMapaExp($params) {
        
        $sql = "DELETE FROM MAPACOMEXP
                WHERE CDVENDEDOR = :P_CDVENDEDOR
                AND CDFILICOMIS = :P_CDFILICOMIS
                AND NRMAPACOMIS = :P_NRMAPACOMIS
                AND NRORG       = :P_NRORG
                AND NRLANCTONF IN (
                SELECT NRLANCTONF FROM NOTAFISCAL 
                WHERE DTEMISSAO BETWEEN NVL(:P_DTINIPERIODO, DTEMISSAO) AND NVL(:P_DTFIMPERIODO, DTEMISSAO))";

        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    protected function deleteMapaRec($params) {
       
        
        $sql = "DELETE FROM MAPACOMREC
                WHERE CDVENDEDOR = :P_CDVENDEDOR
                AND CDFILICOMIS  = :P_CDFILICOMIS
                AND NRMAPACOMIS  = :P_NRMAPACOMIS
                AND NRORG        = :P_NRORG
                AND NRLANCTONF IN
                (SELECT NRLANCTONF
                FROM BAIXARECEBIDA BX
                WHERE BX.DTBAIXAREC BETWEEN NVL(:P_DTINIPERIODO, DTBAIXAREC) AND NVL(:P_DTFIMPERIODO, DTBAIXAREC))";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
    

    
}

   
