<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use \Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\PED\Modules\Pedidos\Services\ped00100PedidosService;
use Teknisa\PED\Services\rtfReaderService;
use Teknisa\PED\Services\Ger00700ClienteService;
use \Teknisa\Libs\Util\Libraries\PHPMailer;
use \Teknisa\Libs\Util\DateUtil;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DependencyInjection\InstanceManager; 

class ped00100PedidosController extends TeknisaCrud {

    protected $dataSourceName = 'pedido_completa';
    protected $dataSourceNameToSave = '';
    protected $itempedido_dataSourceName = 'itempedido_completa';
    protected $comissao_completa_dataSourceName = 'comissao_completa';
    protected $encargo_lancamento_dataSourceName = 'encargo_lancamento';
    protected $imposto_completa_dataSourceName = 'imposto_completa';
    protected $estoque_completa_dataSourceName = 'estoque_completa';
    protected $parameterBag;
    protected $newCode;
    protected $environment;
    protected $entityManager;
    protected $SMTPService;
    protected $pedidosService;
    protected $rtfReaderService;

    public function __construct($crudService, ParameterBag $parameterBag, $newCode, $environment, $entityManager, 
                                    $SMTPService, $pedidosService, $clienteService, $rtfReaderService) {
        parent::__construct($crudService, $parameterBag);
        $this->parameterBag = $parameterBag;
        $this->newCode = $newCode;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->SMTPService = $SMTPService;
        $this->pedidosService = $pedidosService;
        $this->clienteService = $clienteService;
        $this->rtfReaderService = $rtfReaderService;
    }

    public function deleteEncargo($request,$response) {
        
        $this->dataSourceName = 'encargo_lancamento';
        
        parent::delete($request,$response);
        
    }

    public function findPedidoLancamento(DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = 'pedido_completa';
        parent::find($request, $response);
        $rows2 = array();
        $rows = $response->getDataSets()[0]->getRows();
        
        foreach ($rows as $row) {
            /*if ($row["ITENS_CONF"] == 0) {
                $row['IDSITPEDIDO'] = '7';
            }
            if ($row["ITENS_APROV"] == 0) {
                $row['IDSITPEDIDO'] = '8';
            }*/
            
            if ( isset($row["TXOBSPED"]) && strlen($row["TXOBSPED"]) > 0 ) {
                $obs = $this->rtfReaderService->delphi2mobile($row["TXOBSPED"]);
                $row["TXOBSPED"] = trim($obs);
            }
            array_push($rows2, $row);
        }  

        $response->addDataSet(new DataSet('pedido_completa', $rows2));
        $this->dataSourceName = $previous_dataSourceName;
    }
    
    public function findPedidoLancamentotransp(DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = 'pedido_completa_transp';
        parent::find($request, $response);
        $rows2 = array();
        $rows = $response->getDataSets()[0]->getRows();
        
        /*foreach ($rows as $row) {
            if ($row["ITENS_CONF"] == 0) {
                $row['IDSITPEDIDO'] = '7';
            }
            if ($row["ITENS_APROV"] == 0) {
                $row['IDSITPEDIDO'] = '8';
            }
            if ( isset($row["TXOBSPED"]) && strlen($row["TXOBSPED"]) > 0 ) {
                $obs = $this->rtfReaderService->rtf2Html($row["TXOBSPED"]);
                $row["TXOBSPED"] = $obs;
            }
            array_push($rows2, $row);
        }  */
        $response->addDataSet(new DataSet('pedido_completa', $rows));
        $this->dataSourceName = $previous_dataSourceName;
    }

    public function findComissao(DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->comissao_completa_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }

    public function findEncargo(DTO\Request\Filter $request, DTO\Response $response) {
        $this->parameterBagColumns = ['P_CDFILIAL','P_NRPEDIDO'];
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->encargo_lancamento_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }

    public function findImposto(DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->imposto_completa_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }

    public function findEstoque(DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->estoque_completa_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }
    
    public function findPedido(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $previous_dataSourceName = $this->dataSourceName;
            // $filtro = $request->getFilterCriteria()->getConditions();
            
            parent::find($request, $response);
            
            $rows2 = array();
            $rows = $response->getDataSets()[0]->getRows();
                
            foreach ($rows as $row) {
                
                if ( isset($row["TXOBSPED"]) && strlen($row["TXOBSPED"]) > 0 ) {
                    $obs = $this->rtfReaderService->rtf2Html($row["TXOBSPED"]);
                    
                    
                    $row["TXOBSPED"] = $obs;
                }
                array_push($rows2, $row);
            }
            
            $response->addDataSet(new DataSet('pedido_completa', $rows2));
            
            $this->dataSourceName = $previous_dataSourceName;
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function getNewCode($request, $response) {
        $filial = $request->getRow();
        $filial = $filial["filial"];
        $row = new Row ();
        $row->set('NOVOCODIGO', $this->newCode->getCodeByTableName('PEDIDO'.$filial, $this->environment->getNrOrgTrab()));
        $newCode = array();
        array_push($newCode, $row);
        $dataSet = new DataSet ('data',$newCode);
        $response->addDataSet($dataSet);
    }
    
    public function findProdutoApp(DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = 'produto_itemprebase_promoprbase_mobile';
        $rows = new DTO\Response();
        parent::find($request, $rows);
        $rows = $rows->getDataSets()[0]->getRows();
        
        foreach ($rows as &$row) {
            if(gettype($row['VRITEPREBASE']) !== 'integer'){
                $row['VRITEPREBASE'] = floatval($row['VRITEPREBASE']);
            }
            if(gettype($row['VRPESOBRUTPR']) !== 'integer'){
                $row['VRPESOBRUTPR'] = floatval($row['VRPESOBRUTPR']);
            }
            if(gettype($row['VRPESOLIQUPR']) !== 'integer'){
                $row['VRPESOLIQUPR'] = floatval($row['VRPESOLIQUPR']);
            }
            if(gettype($row['VRTOTALPROMO']) !== 'integer'){
                $row['VRTOTALPROMO'] = floatval($row['VRTOTALPROMO']);
            }
        }
        $response->addDataSet(new DataSet('produto_itemprebase_promoprbase_mobile', $rows));
        $this->dataSourceName = $previous_dataSourceName;
    }


    //Verifica diferença entre vendsA e vendsB, o que tiver em vendsA e não em vendsB será retornado
    // Usado para detectar vendedores a serem inseridos no banco OU vendedores a serem deletatos no banco
    public function verificaVendedores($vendsA,$vendsB){
        
        $possui = false;
        $vendsC = array();
        
        foreach($vendsA as $vendA) {
            $possui = false;
            
            foreach($vendsB as $vendB) {
                if($vendA['CDVENDEDOR'] == $vendB['CDVENDEDOR']) {
                    $possui = true;
                }
            }
            if(!$possui) {
                array_push($vendsC,$vendA);
            }
        }
        return $vendsC;
    }

    public function array_some(array $array, callable $fn) {
        foreach ($array as $value) {
            if($fn($value)) {
                return true;
            }
        }
        return false;
    }
    
    public function retornaVendedoresPers($vendedores, $vendedoresRegistrados) {
        
        $arrayVendedores = $this->obj_to_array($vendedores);
        
         $filtrado = array_filter($arrayVendedores, function($row) use($vendedoresRegistrados){
            return $this->array_some($vendedoresRegistrados, function($vendedor) use($row){
                return $vendedor['CDVENDEDOR'] == $row['CDVENDEDOR'];
            });
        });
        
        return $filtrado;
    }

    public function getComissaoVend($pedido, $item, $request, $response, $vendedores) {

        $arrayVend = array($pedido['CDVENDEDOR']);
        $vendedoresRegistrados = $this->pedidosService->selectVendPedAux($pedido);
        
        if (!empty($vendedores)) {
            // Novos
            foreach ($this->verificaVendedores($vendedores,$vendedoresRegistrados) as $vend) {
                
                if (count($vend) > 0) {
                    array_push($arrayVend, $vend['CDVENDEDOR']);
                    
                    $paramVendAux = $pedido;
                    $paramVendAux['CDVENDEDOR'] = $vend['CDVENDEDOR'];
                    
                    $this->pedidosService->insertVendedorPedAux($paramVendAux);
                }
            }
            // Deletáveis
            foreach ($this->verificaVendedores($vendedoresRegistrados,$vendedores) as $vend) {
                $paramVendAux = $pedido;
                $paramVendAux['CDVENDEDOR'] = $vend['CDVENDEDOR'];
                $this->pedidosService->deleteVendedorPedAux($paramVendAux);
            }
            //A continuarem a ser persistidos
            $vendPers = $this->retornaVendedoresPers($vendedores,$vendedoresRegistrados);
            
            if (count($vendPers) > 0) {
                foreach($vendPers as $vendPer) {
                    array_push($arrayVend,$vendPer['CDVENDEDOR']);
                }
            }
        } else {
            foreach($vendedoresRegistrados as $vendReg) {
                array_push($arrayVend, $vendReg['CDVENDEDOR']);
            }
        }
        foreach($arrayVend as $cdVend) {
           $pedido['CDVENDEDOR'] = $cdVend;
            $this->pedidosService->getComissaoVend($pedido, $item, $request, $response);
        }
    }

    public function getImpostoItem($pedido, $item, $request, $response) {
        $filter = array(
            array(
                "columnName" => "CDFILIAL",
                "operator" => "=",
                "value" => $pedido['CDFILIAL']
            )
        );
        $paramped = new DTO\Response();
        $filterCriteria = new FilterCriteria('parampedido', $filter);
        $this->crudService->find($paramped, $filterCriteria);
        $paramped = $paramped->getDataSets(); 
        $paramped = $paramped[0]->getRows()[0];
        
        if (isset($paramped) && $paramped['IDEXIBIMPITPED'] == 'S') {
            $this->pedidosService->getImpostoItem($pedido, $item, $request, $response, 'N');
        }
    }

    public function getTotalImposto($filial, $nrpedido, $request, $response) {
        $this->pedidosService->getTotalImposto($filial, $nrpedido, $request, $response);
    }

    public function getValoresPedido($cdfilial, $nrpedido) {
        return $this->pedidosService->getValoresPedido($cdfilial, $nrpedido);
    }
    
    public function getDataEntrega($request, $response) {
        $row = $request->getRow();

        $dataEntrega = $this->pedidosService->getDataEntrega($row['CDFILIAL'], $row['DTPEDIDO']);
        
        $dataSet = new DataSet("data", $dataEntrega );
        $response->addDataSet($dataSet);
        
    }
    
    public function getRotaEnt($request, $response) {
    	$row = $request->getRow();
    
    	$rota = $this->pedidosService->getRotaEnt($row[0]['IDORIGDESTOP'], $row[0]['CDFILIROTA'], $row[0]['CDCLIENTE']);
    	
    	$dataSet = new DataSet("data", $rota);
    	$response->addDataSet($dataSet);
    	
    }
    
    public function geraReserva($item, $tipooperAtuEst, $tipoPedido, $response) {
        $conditions = array(
            array(
                "value" => $item['CDFILIAL'],
                "operator" => "=",
                "columnName" => "CDFILIAL"
            )
        );        
        $filterCriteria = new FilterCriteria('parampedido', $conditions);
        $responseParams = new DTO\Response();
        $this->crudService->find($responseParams, $filterCriteria);
        $parametros = $responseParams->getDataSets()[0]->getRows();
        
        $filterCriteria = new FilterCriteria('paramfilial', $conditions);
        $responseParams = new DTO\Response();
        $this->crudService->find($responseParams, $filterCriteria);
        $parametrosFilial = $responseParams->getDataSets()[0]->getRows();
        
        if ($parametros[0]['IDUTRESELOTE'] == 'S' && $parametrosFilial[0]['IDCTRLESTQ'] == 'S' && $tipooperAtuEst == 'S' && $tipoPedido == '1'){
            $this->pedidosService->geraReserva($item, $response);
        }
    }

    public function orderRelease($request, $response) { 
        $this->dataSourceNameToSave = 'pedido';
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        //$rows[0] -> Contem os Itens do Pedido
        //$rows[1] -> Contem os Prazos de pagamento do Pedido
        //$rows[2] -> Contem o Pedido
        //$rows[3] -> Contem dados adicionais para a nota
        //$rows[4] -> Contem encargos do Pedido
        //$rows[5] -> Contem vendeores adicionais
        $count = 0;

        foreach ($rows as $row) {
            $rowsNrorg = array();
            foreach($row as $rowNrorg) {
                if (!isset($rowNrorg['NRORG'])) {
                    $rowNrorg['NRORG'] = $this->environment->getNrOrgTrab();
                } else {
                    $rowNrorg['NRORG'] = $rowNrorg['NRORG'] ? $rowNrorg['NRORG'] : $this->environment->getNrOrgTrab();
                }
                if (!isset($rowNrorg['IDATIVO'])) {
                    $rowNrorg['IDATIVO'] = 'S';
                } else {
                    $rowNrorg['IDATIVO'] = $rowNrorg['IDATIVO'] ? $rowNrorg['IDATIVO'] : 'S';
                }
                array_push($rowsNrorg, $rowNrorg);
            }
            $rows[$count] = $rowsNrorg;
            $count++;
        }
        $dataSet = new DataSet ('data',$rows[2]);
        $requestPedido = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        $this->entityManager->beginTransaction();
        try {
            // Salva o Pedido
            parent::save($requestPedido, $response);
            
            
            try {
                $this->saveItem($rows[0], $request, $response);
                for ($i = 0; $i < count($rows[0]); $i++) {
                    $this->geraReserva($rows[0][$i], $rows[2][0]['IDATUESTTPOP'], $rows[2][0]['IDTIPOPEDIDO'], $response);
                }
                for ($i = 0; $i < count($rows[2]); $i++) {
                    for ($e = 0; $e < count($rows[0]); $e++) {
                        if ($rows[2][$i]['NRPEDIDO'] == $rows[0][$e]['NRPEDIDO']) {
                            $rows[2][$i]['IDENTRSAIDOP'] = 'S';

                            $this->getComissaoVend($rows[2][$i], $rows[0][$e], $request, $response, $rows[5]);
                            $this->getImpostoItem($rows[2][$i], $rows[0][$e], $request, $response);
                        }
                    }
                }
                $this->getTotalImposto($rows[2][0]['CDFILIAL'], $rows[2][0]['NRPEDIDO'], $request, $response);

            } catch (\Exception $e) {
                throw $e;
            }

            try {
                $valoresPedido = $this->getValoresPedido($rows[2][0]['CDFILIAL'], $rows[2][0]['NRPEDIDO']);
                $prazos = $this->geraPrazosComImposto($rows[1], $valoresPedido);

                $this->savePrazo($prazos, $request, $response);
            } catch (\Exception $e) {
                throw $e;
            }

            if (isset($rows[3]) && count($rows[3])) {
                foreach ($rows[3] as $row) {
                    $requestSalvarAdic = new DTO\Request\Row($row, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                    $this->saveDadosAdic($requestSalvarAdic, $response);
                }
            }
            for ($i = 0; $i < count($rows[4]); $i++) {
                
                $this->saveEncargo(array($rows[4][$i]), $request, $response);
            }
            
            // salva dados do endereço
            if (isset($rows[6]) && count($rows[6]) && count($rows[6][0]) > 2) {
                try {
                    $this->saveDadosendped($rows[6], $request, $response);
                } catch (\Exception $e) {
                    throw $e;
                }
            }
            // fim dados de endereço
            
            if (isset($rows[2][0]["TXOBSPED"]) && $rows[2][0]["TXOBSPED"]){
                try {
                    
                    $rows[2][0]['TXOBSPED_CLOB'] = $rows[2][0]['TXOBSPED'];
                    
                    $obs = $this->rtfReaderService->mobile2delphi($rows[2][0]['TXOBSPED']);
                    $rows[2][0]['TXOBSPED'] = $obs;
                    
                    $this->saveObsPedido($rows[2][0], $request, $response);
                    $this->entityManager->commit();
                } catch (\Exception $e) {
                    throw $e;
                }
            } else { 
                $this->entityManager->commit();
            }
            
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            $this->entityManager->rollback();
        }
    }

    public function saveItem($itens, $request, $response) {
        $this->dataSourceNameToSave = 'itempedido';
        $dataSet = new DataSet ("data", $itens);
        $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        parent::save($requestSalvar, $response);
    }
    
    public function saveItemPedidoReserva($itens, $request, $response) {
        $this->dataSourceNameToSave = 'itempedido';
        $dataSet = new DataSet ("data", $itens);
        $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        parent::save($requestSalvar, $response);
    }
    
    public function saveItemReserva($reservas, $request, $response) {
        $this->dataSourceNameToSave = 'reserprodped';
        $dataSet = new DataSet ("data", $reservas);
        $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        parent::save($requestSalvar, $response);
    }

    public function qtdeDispEstqReserva2($reserva) {
        $filter = array(
            array(
                "columnName" => "P_CDFILIAL",
                "operator" => "=",
                "value" => $reserva['CDFILIAL']
            ),
            array(
                "columnName" => "P_NRPEDIDO",
                "operator" => "=",
                "value" => $reserva['NRPEDIDO']
            ),
            array(
                "columnName" => "P_NRITEMPED",
                "operator" => "=",
                "value" => $reserva['NRITEMPED']
            ),
            array(
                "columnName" => "P_CDPRODUTO",
                "operator" => "=",
                "value" => $reserva['CDPRODUTO']
            )
        );
        
        $qtdeDispEstqReserva2 = new DTO\Response();
        $filterCriteria = new FilterCriteria('reserprodped_lote_reservaped', $filter);
        $this->crudService->find($qtdeDispEstqReserva2, $filterCriteria);
        $qtdeDispEstqReserva2 = $qtdeDispEstqReserva2->getDataSets();
        
        return $qtdeDispEstqReserva2;
    }
    
    public function salvarManutencaoReserva($request, $response) {
        try {
            
            $this->entityManager->beginTransaction();
            
            $dataSet = $request->getDataSet();
            $itens = $dataSet->getRows()[0][0];
            $reservas = $dataSet->getRows()[1];
            
            $cdfilial = $itens['CDFILIAL'];
            $nrpedido = $itens['NRPEDIDO'];
            
            $this->saveItemPedidoReserva(array($itens), $request, $response);
            
            foreach($reservas as $reserva){
                
                // busca quantidade disponível em estoque para o lote já lançado
                $qtdeDispEstqReserva = $this->pedidosService->qtdeDispEstqReserva($reserva);
                
                if($qtdeDispEstqReserva[0]['QTDISPONIVEL'] >= $reserva['QTRESPRODPED']){
                    $this->saveItemReserva(array($reserva), $request, $response);
                }else{
                    throw new \Exception ('Quantidade solitada indisponível para o lote: <b>'.$reserva['NRLOTEESTQ'].'</b> - Qtde Disp: '.$qtdeDispEstqReserva[0]['QTDISPONIVEL']);
                }
            }
            
            // recalcular os preços, impostos, etc
            $this->pedidosService->recalculaVrPed($cdfilial, $nrpedido);
            
            $this->entityManager->commit();
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
            $this->entityManager->rollback();
        }
    }
    
    public function saveEncargo($encargo, $request, $response) {
        $this->dataSourceNameToSave = 'encargoped';
        $dataSet = new DataSet ("data", $encargo);
        $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        
        parent::save($requestSalvar, $response);
      
    }
    
    public function saveDadosendped($dadosendped, $request, $response) {
        $this->dataSourceNameToSave = 'dadosendped';
        $dataSet = new DataSet ("data", $dadosendped);
        $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        
        parent::save($requestSalvar, $response);
      
    }

    public function saveDadosAdic($request, $response) {
        try{
            $this->dataSourceNameToSave = 'dadosadicped';
            $row = $request->getRow();
            $maxNrdadoadicped = $this->pedidosService->getMaxNrdadoadicped($row['CDFILIAL'], $row['NRPEDIDO']);
            $max = str_pad(($maxNrdadoadicped[0]['MAX']+1), 3, "0", STR_PAD_LEFT);
            $row = new Row ($row);
            $row->set('NRDADOADICPED', $max);

            $requestSalvar = new DTO\Request\Row($row, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            parent::save($requestSalvar, $response);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function savePrazo($prazos, $request, $response) {
        $conditions = array(
            array(
                "value" => $prazos[0]['NRPEDIDO'],
                "operator" => "=",
                "columnName" => "NRPEDIDO"
            ),
            array(
                "value" => $prazos[0]['CDFILIAL'],
                "operator" => "=",
                "columnName" => "CDFILIAL"
            )
        );        
        $filterCriteria = new FilterCriteria('prazopgtoped', $conditions);
        $responsePrazo = new DTO\Response();
        
        $this->crudService->find($responsePrazo, $filterCriteria);
        
        $dataSetPrazos = new DataSet ("data", $responsePrazo->getDataSets()[0]->getRows());
        $requestPrazos = new DTO\Request\dataSet($dataSetPrazos, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
     
        $this->deletarPrazo($requestPrazos, $response);
        
        $this->dataSourceNameToSave = 'prazopgtoped';
            
        for ($i = 0; $i < count($prazos); $i++) {
            $prazos[$i]['__is_new'] = true;
            $requestSalvar = new DTO\Request\Row($prazos[$i], $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            parent::save($requestSalvar, $response);
        }
    }
    
    public function saveObsPedido($rowToSave, $request, $response) {
        $this->dataSourceNameToSave = 'obspedido';
        $row = new Row ();

        if (isset($rowToSave['NRORGINCLUSAO'])) {
            $row->set('NRORG', $rowToSave['NRORGINCLUSAO']);
        } else if (isset($rowToSave['NRORG'])){
            $row->set('NRORG', $rowToSave['NRORG']);
        }
        $row->set('CDFILIAL', $rowToSave['CDFILIAL']);
        $row->set('NRPEDIDO', $rowToSave['NRPEDIDO']);
        $row->set('TXOBSPED', bin2hex($rowToSave['TXOBSPED']));
        $row->set('TXOBSPED_CLOB', $rowToSave['TXOBSPED_CLOB']);
        $row->set('__is_new', $rowToSave['__is_new']);

        try {
            $dataSet = new DataSet ("data", [$row->getArrayCopy()]);
            $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            parent::save($requestSalvar, $response);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function validaAprovar($request, $response) {
        try {
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();

            foreach ($rows as $key => $row) {
                $this->validaPedido($row);
            }
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
            throw $e;
        }
    }
    
    public function aprovarPedido(DTO\Request $request, DTO\Response $response) {
        
        $notify = array();
        $flagChange = false;
        $pedidos = $request->getParameter('dataset');
        
        foreach($pedidos as $pedido) {
            
            $pendFinan = $this->pedidosService->consultaIdPendFin($pedido);
            try {
                
                if ($pendFinan['IDPENDFINAN'] != "1") {
                    
                    $pendencia = $this->clienteService->checkPendencias($pedido);
                    if($pendencia['PENDENCIA'] > 0) {
                        
                        $flagChange = false;
                        $parc_result = $this->pedidosService->defineMensagemPedido($pedido,'Possui pendência');
                        $notify = $this->pedidosService->mesclaPedidoPendencia($parc_result,$notify);
                    } else {
                        
                        $flagChange = true;
                        $notify[] = $this->pedidosService->defineMensagemPedido($pedido,'Aprovado');
                    } 
                } else {
                    $flagChange = true;
                    $notify[] = $this->pedidosService->defineMensagemPedido($pedido,'Aprovado');
                }
                if($flagChange) {
                    
                    $this->pedidosService->changeStatusPed($pedido);
                    $flagChange = false;
                }   
            } catch (\Exception $e) {
                
                $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
                throw $e;
            }
        }
        $dataSet = new DataSet("mensagem", $notify );
        $response->addDataSet($dataSet);
    }

    public function validaPedido($row) {
        try {
            
            $this->pedidosService->validaPedido($row);
            
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function validaItens($pedido, $row) {
        try {
            
            $this->pedidosService->validaItens($pedido,$row);
            
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function consultaPendencia($request, $response) {
        try {
            
            $rows = $request->getDataSet()->getRows();
            $result = $this->pedidosService->consultaPendencia($rows);
            $dataSet = new DataSet ("pendencias", $result);
            $response->addDataSet($dataSet);
            
        } catch(\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }
    
    private function obj_to_array($data){
	    if (is_array($data) || is_object($data)){
	        $result = array();
	        foreach ($data as $key => $value){
	            $result[$key] = $this->obj_to_array($value);
	        }
	        return $result;
	    }
	    return $data;
	}

    public function updateOrder($request, $response) {
        try {
            $this->entityManager->beginTransaction();

            $rows = $request->getDataSet()->getRows();
            
            //  $rows[0][n] -> contem os itens  do pedido
            //  $rows[1][n] -> contem os prazos do pedido
            //  $rows[2][0] -> contem o pedido
            //  $rows[3][n] -> contem os encargos do pedido
            //  $rows[4][n] -> contem vendedores adicionais
               
            // foreach ($rows as $row) {
                $this->validaPedido($rows[2][0]);
            // }
            
            $this->dataSourceNameToSave = 'pedido';
            
            $dataSet = new DataSet ("data", array($rows[2][0]));
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            
            parent::save($requestSalvar, $response);
            
            if($response->getError()){
                throw new  \Exception ('Error '.$response->getError()->getMessage());
            }
            
            if(isset($rows[3])){
                for ($i = 0; $i < count($rows[3]); $i++) {
                    $this->saveEncargo(array($rows[3][$i]), $request, $response);
                }
            }    
            
            if($response->getError()){
                throw new  \Exception ('Error '.$response->getError()->getMessage());
            }
            
            for ($i = 1; $i < 2; $i++) {
              for ($e = 0; $e < count($rows[$i]); $e++) {
                    if (isset($rows[$i][$e]['__is_new'])) {
                        $rows[$i][$e]['__is_new'] = false;
                    } else {
                        $rows[$i][$e]['__is_new'] = true;
                    }
                }
            }
            
            
            $rows[0] = $this->pedidosService->situacaoItens($rows[0],$rows[2][0]);

            if($response->getError()){
                throw new  \Exception ('Error '.$response->getError()->getMessage());
            }
            
            for ($i = 0; $i < count($rows[0]); $i++) {
                // if(!(isset($rows[0][$i]['changePrazo']))){
                    $this->saveItem(array($rows[0][$i]), $request, $response);
                    
                    $this->geraReserva($rows[0][$i], $rows[2][0]['IDATUESTTPOP'], $rows[2][0]['IDTIPOPEDIDO'], $response);
                // }
            } 
            

            if($response->getError()){ 
                throw new  \Exception ('Error '.$response->getError()->getMessage());
            }
            
            for ($i = 0; $i < count($rows[2]); $i++) {
                for ($e = 0; $e < count($rows[0]); $e++) {
                    if ($rows[2][$i]['NRPEDIDO'] == $rows[0][$e]['NRPEDIDO']) {
                        $rows[2][$i]['IDENTRSAIDOP'] = 'S';
                        $this->getComissaoVend($rows[2][$i], $rows[0][$e], $request, $response, $rows[4]);
                        $this->getImpostoItem($rows[2][$i], $rows[0][$e], $request, $response);
                    }
                }
            }
            if($response->getError()){
                throw new  \Exception ('Error '.$response->getError()->getMessage());
            }
            
            $valoresPedido = $this->getValoresPedido($rows[2][0]['CDFILIAL'], $rows[2][0]['NRPEDIDO']);
            
            $prazos = $this->geraPrazosComImposto($rows[1], $valoresPedido);
            
            if ($response->getError()) {
                throw new \Exception ($response->getError()->getMessage());
            }
            

            if (count($prazos) > 0 ) {
                $this->savePrazo($prazos, $request, $response);
            }
            
            if($response->getError()){
                throw new  \Exception ('Error '.$response->getError()->getMessage());
            }

            $this->getTotalImposto($rows[2][0]['CDFILIAL'], $rows[2][0]['NRPEDIDO'], $request, $response);
            
            if($response->getError()){
                throw new  \Exception ('Error '.$response->getError()->getMessage());
            }
            
            $conditions = array(
                array(
                    "value" => $rows[2][0]['NRPEDIDO'],
                    "operator" => "=",
                    "columnName" => "NRPEDIDO"
                ),
                array(
                    "value" => $rows[2][0]['CDFILIAL'],
                    "operator" => "=",
                    "columnName" => "CDFILIAL"
                )
            );
            $filterCriteria = new FilterCriteria('obspedido', $conditions);
            $this->crudService->find($response, $filterCriteria);
            // Verifica se ha uma observação para updatar, exluir ou adicionar
            $obsDataSet = $response->getDataSets();
            foreach ($obsDataSet as $key => $dataSets) {
                if ($dataSets->getDataSourceName() == 'obspedido') {
                    $obsRow = $obsDataSet[$key]->getRows();
                }
            }
            if (count($obsRow)) {
                try {
                    if (isset($rows[2][0]['TXOBSPED']) && strlen($rows[2][0]['TXOBSPED']) > 0) {
                        
                        $rows[2][0]['TXOBSPED_CLOB'] = $rows[2][0]['TXOBSPED'];
                        
                        $obs = $this->rtfReaderService->mobile2delphi($rows[2][0]['TXOBSPED']);
                        $rows[2][0]['TXOBSPED'] = $obs;
                        
                        $obsRow[0]['__is_new'] = false;
                        $this->saveObsPedido($rows[2][0], $request, $response);
                    } else {
                        $obsdata = new DataSet ("data", $obsRow);
                        $requestDelObs = new DTO\Request\dataSet($obsdata, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                        $this->dataSourceName = 'obspedido';
                        parent::delete($requestDelObs, $response);
                        $this->dataSourceName = 'pedido';
                    }
                } catch (\Exception $e) {
                    throw $e;
                }
            } else {
                if (isset($rows[2][0]['TXOBSPED']) && strlen($rows[2][0]['TXOBSPED']) > 0) {
                    try {
                        
                        $rows[2][0]['TXOBSPED_CLOB'] = $rows[2][0]['TXOBSPED'];
                        
                        $obs = $this->rtfReaderService->mobile2delphi($rows[2][0]['TXOBSPED']);
                        $rows[2][0]['TXOBSPED'] = $obs;
                        
                        $isNew = $rows[2][0]['__is_new'];
                        $rows[2][0]['__is_new'] = true;
                        $erro = $this->saveObsPedido($rows[2][0], $request, $response);
                        if (!$isNew) {
                            $rows[2][0]['__is_new'] = false;
                        }
                    } catch (\Exception $e) {
                        throw $e;
                    }
                }
            }
            if($response->getError()){
                throw new  \Exception ('Error '.$response->getError()->getMessage());
            }
            
            $this->entityManager->commit();
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            $this->entityManager->rollback();
        }
    }

    public function deleteAllVendPedAux($request, $response) {
        
        try {
            
            $this->entityManager->beginTransaction();
            
            $pedido = $request->getDataSet()->getRows()[0];
            $dataSet = new DataSet("deleteAll_vendpedaux", $this->pedidosService->deleteAllVendPedAux($pedido));
            $response->addDataSet($dataSet);
            
            $this->entityManager->commit();
            
        } catch (\Exception $e) {
            
            $response->setError(new Error("Error in delete data. ". $e->getMessage(), 500));
            $this->entityManager->rollback();
            
        }
        
    }

    public function selectVendPedAux($request, $response) {
        
        try {
            
            $this->entityManager->beginTransaction();
            
            $pedido = $request->getDataSet()->getRows()[0];
            $dataSet = new DataSet("vendedores", $this->pedidosService->selectVendPedAux($pedido));
            $response->addDataSet($dataSet);
            
            $this->entityManager->commit();
            
        } catch (\Exception $e) {
            
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            $this->entityManager->rollback();
            
        }
        
    }

    public function geraPrazosComImposto($prazos, $valoresPedido, $encargos = null) { 
        try {
            $aux = 0;
            if (isset($encargos) && count($encargos) > 0) {
                foreach ($encargos as $encargo) {
                    if (isset($encargo['VRENCARGOPED'])){
                        $valoresPedido[0]['VRTOTALPED'] = $valoresPedido[0]['VRTOTALPED'] + $encargo['VRENCARGOPED'];
                    }
                }
                foreach ($prazos as $key => &$prazo) {
                   if ($key != (count($prazos)-1)) {
                        $percent  = number_format($prazo['VRPERCPGTOPED'] ,2 ,"." ,"")/100;
                        $prazo['VRPARCELA'] = $valoresPedido[0]['VRTOTALPED']*$percent;
                        $prazo['VRPARCELA'] = number_format($prazo['VRPARCELA'] ,2 ,"." ,"");
                        $aux += $prazo['VRPARCELA'];
                    } else {
                        $prazo['VRPARCELA'] = number_format($prazo['VRPARCELA'] ,2 ,"." ,"");
                        $prazo['VRPARCELA'] = $valoresPedido[0]['VRTOTALPED'] - $aux;
                    }
                }
                return $prazos;
            } else {
                foreach ($prazos as $key => &$prazo) {
                    if ($key != (count($prazos)-1)) {
                        $percent  = number_format($prazo['VRPERCPGTOPED'] ,2 ,"." ,"")/100;
                        $prazo['VRPARCELA'] = $valoresPedido[0]['VRTOTALPED']*$percent;
                        $prazo['VRPARCELA'] = number_format($prazo['VRPARCELA'] ,2 ,"." ,"");
                        $aux += $prazo['VRPARCELA'];
                    } else {
                        $prazo['VRPARCELA'] = number_format($prazo['VRPARCELA'] ,2 ,"." ,"");
                        $prazo['VRPARCELA'] = $valoresPedido[0]['VRTOTALPED'] - $aux;
                    }
                }
                return $prazos;
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function updatePrazo($request, $response) {
        $this->dataSourceName = 'prazopgtoped';
        $data = $request->getDataSet();
        $rows = $data->getRows();

        for($i = 0; $i < count($rows); $i++) {
            try {
                $dataSet = new DataSet ("data", array($rows[$i]->getArrayCopy()));
                $requestDel = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                parent::save($requestDel, $response);
            } catch (\Exception $e) {
                if(strlen($response->getError()) > 0){
                    $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
                    throw $e;
                }
            }
        }
    }

    public function changeStatusItemPed($request, $response) {
        try {
            $this->entityManager->beginTransaction();
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            
            $this->pedidosService->changeStatusItemPed($rows);

            $this->entityManager->commit();
            
        } catch (\Exception $e) {
            $this->entityManager->rollback();
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            throw $e;
        }
    }

    public function changeStatusPed($request, $response) {
        try {
            $this->entityManager->beginTransaction();

            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            
            $this->pedidosService->changeStatusPed($rows); 

           
            $this->entityManager->commit();
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            $this->entityManager->rollback();
            throw $e;
        }
    }

    public function removeCurrentStatus($request, $response) {
        try {
            
            $this->entityManager->beginTransaction();
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();

            // throw new \Exception ('Ronaldinho');
            
            $nrpedidos = array();
            $nrorgs = array();
            
            foreach ($rows as $item) {
                $nrpedidos[] = $item['NRPEDIDO'];
                $nrorgs[] = $item['NRORG'];
            }
            
            $conditions = array(
                array(
                    "columnName" => "NRPEDIDO",
                    "operator" => "IN",
                    "value" => $nrpedidos
                ),
                array(
                    "columnName" => "NRORG",
                    "operator" => "IN",
                    "value" => $nrorgs
                )
            );
            //Procura na tabela historico os registros relacionados ao pedido que os itens pertencem
            $filterCriteria = new FilterCriteria('hisitemped', $conditions);
            $this->crudService->find($response, $filterCriteria);
            $datas = $response->getDataSets();
            foreach ($datas as $data) {
                if ($data->getDataSourceName() == 'hisitemped') {
                    $historicos = $data->getRows();
                }
            }
            $datadefault = '01/01/1900 00:00:00';
            $histItemPed = array();
            $ids = array();
            //Pega o registro mais recente da tabela historico
            foreach ($historicos as &$historico) {
                if (array_key_exists($historico['NRITEMPED'], $ids)) {
                    $dataArmazenada = DateUtil::getDataDeString($ids[$historico['NRITEMPED']]['DTHRHIST'], "d/m/Y H:i:s");
                    $dataAtual = DateUtil::getDataDeString($historico['DTHRHIST'], "d/m/Y H:i:s");

                    $data = DateUtil::comparaDatas($dataAtual, $dataArmazenada, 2);
                } else {
                    $data = true;
                }
                if ($data) {
                    $ids[$historico['NRITEMPED']] = $historico;
                }
            }
            
            // Altera o Status do item de acordo com o registro mais recente da tabela de historico
            // Tambem cria o array que ira ser salvo na tabela de historico
            
            foreach ($rows as $key => &$row) {
                if ($row['IDSITITEMPED'] == '5') {
                    $row['IDSITITEMPED'] = $ids[$row['NRITEMPED']]['IDSITANTHIST'];

                    $histItemPed[$key]['IDSITANTHIST']  = $ids[$row['NRITEMPED']]['IDSITATUHIST'];
                    $histItemPed[$key]['IDSITATUHIST']  = $ids[$row['NRITEMPED']]['IDSITANTHIST'];
                } else {
                    $histItemPed[$key]['IDSITANTHIST']  = $row['IDSITITEMPED'];
                    // Muda o status do Pedido dependendo do status dos itens do mesmo
                    if ($row['IDSITITEMPED'] == '2') {
                        // Confirmado -> Pendente
                        $row['IDSITITEMPED'] = '1';
                        $histItemPed[$key]['IDSITATUHIST'] = $row['IDSITITEMPED'];

                    } else if ($row['IDSITITEMPED'] == '3') {
                        // Aprovado -> Confirmado
                        $row['IDSITITEMPED'] = '2';
                        $histItemPed[$key]['IDSITATUHIST'] = $row['IDSITITEMPED'];

                    } else if ($row['IDSITITEMPED'] == '4') {
                        // Parcial -> Aprovado
                        $row['IDSITITEMPED'] = '3';
                        $histItemPed[$key]['IDSITATUHIST'] = $row['IDSITITEMPED'];

                    } else if ($row['IDSITITEMPED'] == '5') {
                        // Cancelado -> Ultimo status salvo no historico
                        $row['IDSITITEMPED'] = $ids[$row['NRITEMPED']]['IDSITANTHIST'];

                        $histItemPed[$key]['IDSITANTHIST']  = $ids[$row['NRITEMPED']]['IDSITATUHIST'];
                        $histItemPed[$key]['IDSITATUHIST']  = $ids[$row['NRITEMPED']]['IDSITANTHIST'];
                    } else if ($row['IDSITITEMPED'] == '6') {
                        // Liquidado -> Aprovado
                        $row['IDSITITEMPED'] = '3';
                        $histItemPed[$key]['IDSITATUHIST'] = $row['IDSITITEMPED'];

                    } else if ($row['IDSITITEMPED'] == '7') {
                        // Liq Manual -> Aprovado
                        $row['IDSITITEMPED'] = '3';
                        $histItemPed[$key]['IDSITATUHIST'] = $row['IDSITITEMPED'];
                    }
                }
                $histItemPed[$key]['__is_new']      = true;
                $histItemPed[$key]['DTHRHIST']      = $row['DTHORA']; // data e hora de hoje;
                $histItemPed[$key]['CDFILIAL']      = $row['CDFILIAL'];
                $histItemPed[$key]['NRPEDIDO']      = $row['NRPEDIDO'];
                $histItemPed[$key]['NRITEMPED']     = $row['NRITEMPED'];
                $histItemPed[$key]['NRORG']     = $row['NRORG'];
                
            }
            $this->dataSourceName = 'itempedido';
            $dataSet = new DataSet ("data", $rows);
            $requestSalvar1 = new DTO\Request\dataSet($dataSet, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
            

            parent::save($requestSalvar1, $response);
            
            // salva a alteração feita no Status dos itens na tabela de historico
            $this->dataSourceName = 'ped_hisitemped';
            // $dataSetHist = new DataSet ("data", $histItemPed);
            
            
            foreach ($histItemPed as $hist) {
                $this->pedidosService->insertHist($hist);
            }
            
            // $requestSalvar2 = new DTO\Request\dataSet($dataSetHist, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
            // parent::save($requestSalvar2, $response);
            
            // Procura o pedido dos itens chamados para essa função
            $filterCriteria = new FilterCriteria('pedido', $conditions);
            $responsePedidos = new DTO\Response();
            
            
            $this->crudService->find($responsePedidos, $filterCriteria);
            
            $datas = $responsePedidos->getDataSets();
            
            
            if (!empty($datas)) {
                foreach ($datas as $data) {
                    if ($data->getDataSourceName() == 'pedido' && $data->getRows()[0]['NRPEDIDO'] == $rows[0]['NRPEDIDO']) {
                        $pedidos = $data->getRows();
                    }
                }
            }
            $filter = array(
                array(
                    "value" => $rows[0]['NRPEDIDO'],
                    "operator" => "=",
                    "columnName" => "NRPEDIDO"
                ),
                array(
                    "value" => $rows[0]['CDFILIAL'],
                    "operator" => "=",
                    "columnName" => "CDFILIAL"
                )
            );

            $itens = new DTO\Response();
            $filterCriteria = new FilterCriteria('itempedido', $filter);
            $this->crudService->find($itens, $filterCriteria);
            $itens = $itens->getDataSets()[0]->getRows();

            $status = array();
            // Armazena no array os status dos itens do pedido
            foreach ($itens as $key => $row) {
                $status[$row['NRITEMPED']] = $row['IDSITITEMPED'];
            }
            // Muda o status do Pedido dependendo do status dos itens do mesmo
            if (in_array('7', $status)) {
                $pedidos[0]['IDSITPEDIDO'] = '6';

            } else if (in_array('6', $status)) {
                $pedidos[0]['IDSITPEDIDO'] = '5';

            } else if (in_array('5', $status)) {
                $pedidos[0]['IDSITPEDIDO'] = '4';

            } else if (in_array('4', $status)) {
                $pedidos[0]['IDSITPEDIDO'] = '3';

            } else if (in_array('3', $status)) {
                $pedidos[0]['IDSITPEDIDO'] = '2';

            } else if (in_array('2', $status)) {
                $pedidos[0]['IDSITPEDIDO'] = '2';

            } else if (in_array('1', $status)) {
                $pedidos[0]['IDSITPEDIDO'] = '1';
            }
            $this->dataSourceName = 'pedido';
            
            
            $dataSet = new DataSet ("data", $pedidos);
            $requestSalvar3 = new DTO\Request\dataSet($dataSet, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
            
            
            parent::save($requestSalvar3, $response);
            
            $this->entityManager->commit();
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            $this->entityManager->rollback();
            throw $e;
            
        }
    }

    public function removeCurrentStatusPed($request, $response) {
        try {
            $this->entityManager->beginTransaction();

            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            $itensPedido = array();

            foreach ($rows as $row) {
                $this->validaPedido($row);
            }

            $pedidosFilter = array();
            // Armazena na variavel pedidos os numeros dos pedidos selecionados
            foreach ($rows as $pedido) {

                $filter = array(
                    'NRPEDIDO' => $pedido['NRPEDIDO'],
                    'NRORG' => $pedido['NRORG'],
                    'CDFILIAL' => $pedido['CDFILIAL']
                );
                
                array_push($pedidosFilter, $filter);
            }
            
            foreach ($pedidosFilter as $filter) {
                
                $conditions = array(
                    array(
                        "columnName" => "NRPEDIDO",
                        "operator" => "=",
                        "value" => $filter['NRPEDIDO']
                    ),
                    array(
                        "columnName" => "NRORG",
                        "operator" => "=",
                        "value" => $filter['NRORG']
                    ),
                    array(
                        "columnName" => "CDFILIAL",
                        "operator" => "=",
                        "value" => $filter['CDFILIAL']
                    )
                );
                $filterCriteria = new FilterCriteria('itempedido', $conditions);
                $this->crudService->find($response, $filterCriteria);
                $datas = $response->getDataSets();
                $aux = true;
                
                foreach ($datas as $data) {
                    if ($data->getDataSourceName() == 'itempedido' && $aux && $data->getRows()[0]['NRPEDIDO'] == $filter['NRPEDIDO']) {
                        $itensPedido = $data->getRows();
                        $aux = false;
                    }
                }

                // $itensPedido = $itensPedido[0]->getRows();
                foreach ($itensPedido as &$item) {
                    $item['DTHORA']     = $rows[0]['DTHORA'];
                    $item['CALLED_BY']  = $rows[0]['CALLED_BY'];

                }
                
                $itensPedido = new DataSet ("data", $itensPedido);
                $itensPedido = new DTO\Request\dataSet($itensPedido, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
                

                $this->removeCurrentStatus($itensPedido, $response);
            }

            $this->entityManager->commit();
        } catch (\Exception $e) {
            
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            $this->entityManager->rollback();
            throw $e;
            
        }
    }
    

    public function enviarPedido($request, $response) {
        $this->dataSourceNameToSave = 'pedido_completa';
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        // $rows[0] -> pedidos
        // $rows[1] -> prazos
        // $rows[2] -> itens
        // $rows[3] -> observação do pedido
        // $rows[4] -> dados adicionais
        // $rows[5] -> encargo
        // $rows[6] -> dados da Filial

        $oldCode = array();
        for ($i=0; $i < count($rows[0]); $i++) {
            $oldCode[$i]['CDANTIGO'] = $rows[0][$i]['NRPEDIDO'];
            $rows[0][$i]['NRPEDIDO'] = $this->newCode->getCodeByTableName('PEDIDO'.$rows[0][$i]['CDFILIAL'], $this->environment->getNrOrgTrab());
            $oldCode[$i]['CDNOVO'] = $rows[0][$i]['NRPEDIDO'];
        }
        
        $idx = array(1,2,3,4,6);
        for ($i= 0; $i < count($idx); $i++) { 
            $rows[$idx[$i]] = $this->atualizaNrpedido($rows[$idx[$i]], $oldCode);
        }
        
        $dataSet = new DataSet ('data',$rows[0]->getArrayCopy());
        
        $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        $dataCode = new DataSet ("oldCode", $oldCode);
        try {
            $this->entityManager->beginTransaction();
            
            parent::save($requestSalvar, $response);
            $this->enviarItem($rows, $request, $response, $oldCode);
            
            /* salva endereço do pedido */
            $this->salvarDadosendpedAPP($rows[0], $request, $response);
            /* fim salva endereço do pedido */
            
            $valoresPedido = array ();
            for ($i = 0; $i < count($rows[0]); $i++) {
                for ($e = 0; $e < count($rows[2]); $e++) {
                    if ($rows[0][$i]['NRPEDIDO'] == $rows[2][$e]['NRPEDIDO']) {
                        $this->getComissaoVend($rows[0][$i], $rows[2][$e], $request, $response, []);
                        $this->getImpostoItem($rows[0][$i], $rows[2][$e], $request, $response);
                    }
                }
                array_push($valoresPedido, $this->getValoresPedido($rows[0][$i]['CDFILIAL'], $rows[0][$i]['NRPEDIDO']));
            }
            $prazos = array ();
            $prazosPed = array();
            $encargoPed = array();

            
            for ($i = 0; $i < count($valoresPedido); $i ++) {
                for ($j = 0; $j < count($rows[1]); $j ++) {
                    if ($valoresPedido[$i][0]['NRPEDIDO'] == $rows[1][$j]['NRPEDIDO']) {
                        array_push($prazosPed, $rows[1][$j]);
                    }
                }
                for ($j = 0; $j < count($rows[6]); $j ++) {
                    if ($valoresPedido[$i][0]['NRPEDIDO'] == $rows[6][$j]['NRPEDIDO']) {
                        array_push($encargoPed, $rows[6][$j]);
                    }
                }
                array_push($prazos, $this->geraPrazosComImposto($prazosPed, $valoresPedido[$i], $encargoPed));
                $prazosPed = array();
                $encargoPed = array();
            }
            
            for ($j = 0; $j < count($prazos); $j ++) {
                $this->enviarPrazo($prazos[$j], $rows, $request, $response, $oldCode);
            }
            
            if (count($rows[3]) > 0) {
                $aux = $this->dataSourceNameToSave;
                for ($i = 0; $i < count($rows[0]); $i++) {
                    if (isset($rows[0][$i]['CDFILIAL']) && isset($rows[0][$i]['NRPEDIDO']) && isset($rows[0][$i]['TXOBSPED'])) {
                        //$this->enviarObservacao($obs, $request, $response);
                        
                        $rows[0][$i]['TXOBSPED_CLOB'] = $rows[0][$i]['TXOBSPED'];
                        
                        $observacao = $this->rtfReaderService->mobile2delphi($rows[0][$i]['TXOBSPED']);
                        $rows[0][$i]['TXOBSPED'] = $observacao;
                        
                        $this->dataSourceNameToSave = 'obspedido';
                        $obs = array(
                            array(
                                'CDFILIAL'=> $rows[0][$i]['CDFILIAL'],
                                'NRPEDIDO'=> $rows[0][$i]['NRPEDIDO'],
                                'TXOBSPED_CLOB'=> $rows[0][$i]['TXOBSPED_CLOB'],
                                'TXOBSPED'=> bin2hex($rows[0][$i]['TXOBSPED']),
                                '__is_new'=> true
                            )
                        );
                        
                        $dataSet = new DataSet ("data", $obs);
                        $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                        parent::save($requestSalvar, $response);
                    }
                }
                $this->dataSourceNameToSave = $aux;
            }
            
            if (count($rows[4])) {
                for ($i = 0; $i < count($rows[4]); $i++) {
                    if (isset($rows[4][$i]['CDFILIAL']) && isset($rows[4][$i]['NRDADOADICPED']) && isset($rows[4][$i]['NRPEDIDO']) && isset($rows[4][$i]['DSDADOADICPED'])) {
                        $this->enviarDadosAdic($rows[4][$i], $request, $response, $oldCode);
                    }
                }
            }
            
            if (isset($rows[6]) && count($rows[6])) {
                for ($i = 0; $i < count($rows[6]); $i++) {
                    if (isset($rows[6][$i]['CDFILIAL']) && isset($rows[6][$i]['CDENCARGO']) && isset($rows[6][$i]['NRPEDIDO'])) {
                        $this->enviarEncargos($rows[6][$i], $request, $response, $oldCode);
                    }
                }
            }
            
            $this->insereImpostotalPed($rows[0]);
            $response->addDataSet($dataCode);
            
            $this->entityManager->commit();
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function salvarDadosendpedAPP($pedidos, $request, $response){
        try {
            foreach($pedidos as $pedido){
                
                $filter = array(
                    array(
                        "columnName" => "CDCLIENTE",
                        "operator" => "=",
                        "value" => $pedido['CDCLIENTE']
                    ),
                    array(
                        "columnName" => "IDTPENDECLIE",
                        "operator" => "=",
                        "value" => 'T'
                    )
                );
                
                $endeclie = new DTO\Response();
                $filterCriteria = new FilterCriteria('endeclie_endereco', $filter);
                $this->crudService->find($endeclie, $filterCriteria);
                $endeclie = $endeclie->getDataSets();
                
                
                if(count($endeclie[0]->getRows()) > 0){
                    $endeclie = $endeclie[0]->getRows()[0];
                    
                    $endPed['CDFILIAL']         = $pedido['CDFILIAL'];
                    $endPed['NRPEDIDO']         = $pedido['NRPEDIDO'];
                    $endPed['NMRAZSOCPED']      = $pedido['NMRAZSOCCLIE'];
                    $endPed['CDCLIENTE']        = $pedido['CDCLIENTE'];
                    $endPed['NRINSJURPED']      = '';
                    
                    $endPed['IDTPENDECLIE']     = $endeclie['IDTPENDECLIE'];
                    $endPed['DSENDEPED']        = $endeclie['DSENDECLIE'];
                    $endPed['NRCEPPED']         = $endeclie['NRCEPCLIE'];
                    $endPed['NMPAISPED']        = $endeclie['NMPAIS'];
                    $endPed['NMMUNIPED']        = $endeclie['NMMUNICIPIO'];
                    $endPed['NMBAIRROPED']      = $endeclie['NMBAIRCLIE'];
                    $endPed['NMESTADOPED']      = $endeclie['NMESTADO'];
                    $endPed['SGESTADOPED']      = $endeclie['SGESTADO'];
                    $endPed['CDPAISPED']        = $endeclie['CDPAIS'];
                    $endPed['CDMUNICIPIOPED']   = $endeclie['CDMUNICIPIO'];
                    
                    $endPed['NRSEQEND']         = 1;
                    $endPed['__is_new']         = true;
                    
                    $dadosendped[0] = $endPed;
                    
                    $this->saveDadosendped($dadosendped, $request, $response);
                    
                }
            }
            
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            throw $e;
        }
        
    }

    public function atualizaNrpedido($linhas, $oldCode) {
        
        for ($i = 0; $i < count($linhas); $i++) {
            for ($e = 0; $e < count($oldCode); $e++) {
                if ($linhas[$i]['NRPEDIDO'] == $oldCode[$e]['CDANTIGO']) {
                    $linhas[$i]['NRPEDIDO'] = $oldCode[$e]['CDNOVO'];
                }
            }
        }       
        return $linhas;
    }
    
    public function enviarItem($rows, $request, $response, $oldCode) {
        $this->dataSourceNameToSave = 'itempedido_completa';
        try {
            $dataSet = new DataSet ("data", $rows[2]->getArrayCopy());
            $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            parent::save($requestSalvar, $response);
            if (strlen($response->getError()) > 0) {
                throw new \Exception ($response->getError()->getMessage());
            }
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            throw $e;
        }
    }

    public function enviarPrazo($prazos, $rows, $request, $response, $oldCode) {
        $this->dataSourceNameToSave = 'prazopgtoped';
        try {
            $dataSet = new DataSet ("data", $prazos);
            $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            parent::save($requestSalvar, $response);
            if (strlen($response->getError()) > 0) {
                throw new \Exception ($response->getError()->getMessage());
            }
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            throw $e;
        }
    }

    public function enviarObservacao($obs, $request, $response) {
        $this->dataSourceNameToSave = 'obspedido_pedido';
        
        try {
            $pedidosToSave = array();
            $obs['TXOBSPED'] = bin2hex($obs['TXOBSPED']);
            $filter = array(
                array(
                    "columnName" => "NRPEDIDO",
                    "operator" => "=",
                    "value" => $obs['NRPEDIDO']
                ),
                array(
                    "columnName" => "CDFILIAL",
                    "operator" => "=",
                    "value" => $obs['CDFILIAL']
                )
            ); 
            $pedido = new DTO\Response();
            $filterCriteria = new FilterCriteria('obspedido', $filter);
            $this->crudService->find($pedido, $filterCriteria);
            
            if (count($pedido->getDataSets()[0]->getRows()) <= 0) {
                array_push($pedidosToSave, $obs);
                
                $dataSet = new DataSet ("data", $pedidosToSave);
                $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                parent::save($requestSalvar, $response);
                if (strlen($response->getError()) > 0) {
                    throw new \Exception ($response->getError()->getMessage());
                }
            }
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            throw $e;
        }
    }

    public function enviarDadosAdic($dadosAdic, $request, $response, $oldCode) {
        $this->dataSourceNameToSave = 'dadosadicped';
        try {
            $dataSet = new DataSet ("data", array($dadosAdic));
            $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            parent::save($requestSalvar, $response);
            if (strlen($response->getError()) > 0) {
                throw new \Exception ($response->getError()->getMessage());
            }
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            throw $e;
        }
    }
    
    public function enviarEncargos($encargo, $request, $response, $oldCode) {
        $this->dataSourceNameToSave = 'encargoped_completa';
        try {
            $dataSet = new DataSet ("data", array($encargo));
            $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            parent::save($requestSalvar, $response);
            if (strlen($response->getError()) > 0) {
                throw new \Exception ($response->getError()->getMessage());
            }
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            throw $e;
        }
    }
    
    public function insereImpostotalPed($pedidos) {
        foreach ($pedidos as $pedido) {
            $impostoPed = $this->pedidosService->getImpostosped($pedido);
            foreach ($impostoPed as $imp) {
                $imp['NRPEDIDO'] = $pedido['NRPEDIDO'];
                $imp['CDFILIAL'] = $pedido['CDFILIAL'];
                $this->pedidosService->saveImpostototped($imp); // FALTA VER ESA FUNÇÂO
            }
        }
    }
    
    public function getSmtp($pedido){
        try{

            return $this->pedidosService->getSmtp($pedido);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function tabelaItemPedido($pedido){
        try{
            return $this->pedidosService->tabelaItempedido($pedido);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function endEntregaPed($pedido){
        try{
            return $this->pedidosService->endEntregaPed($pedido);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function mailBody($pedido, $itens, $tabela,$entrega){
        $data = substr($pedido['DTENTPED'],0,8); 
        $valorTot = number_format($pedido['VRTOTPEDLIQ'], 2, ',', '.');
        $valorTotImp = number_format($pedido['VRTOTALPED'], 2, ',', '.');

        try{
        
                        // corpo do email
            $html = '<div class="container-flex align-content-center" style="width: 90%;">
                            <div>
                                <h4 style="padding:1.5px; text-align:right; background-color:#3CB371; color:white;">Nº do Pedido# '.$pedido['NRPEDIDO'].'</h4>
                            
                                <h3>Prezado <span style="font-size:15px;">'.$pedido['NMFANTCLIE'].'</span></h3>
                                
                                <p style="font-size: 1.2rem; margin-left:15px;">Agradecemos por comprar na <strong>'.$pedido['NMFILIAL'].'</strong>. Seu pedido está sendo processado e será 
                                enviado conforme dados anexados abaixo</p>
                            </div>
                            
                            <div>
                                <p style="background-color:#3CB371;color:white;margin-bottom:0px;"><span style="margin-left:10px; ">Resumo do Pedido</span></p>
                                <table style=" width: 100%; background-color:#E0FFFF; margin-top:3px">
                                    <thead>
                                        <tr style="font-size: 1.1rem;">
                                          <th style="text-align:center;"><strong>Produto</strong></th>
                                          <th style="text-align:right;"><strong>Quantidade</strong></th>
                                          <th style="text-align:right;"><strong>Valor Unitário</strong></th>
                                        </tr>
                                    </thead>
                                  '.$tabela.'
                                </table>
                            </div>

                        <div class="card-text">
                            <p style="text-align:right;">Valor total: <strong>R$ '.$valorTot.'</strong><br>
                                        Valor total c/ Imposto: 
                                        <strong>R$ '.$valorTotImp.'</strong></p>
                        </div>
                        <div class="card-flex" style="background-color:#DCDCDC; border-top:2px ridge darkgreen;">
                            <h4><strong>Dados de entrega</strong></h4>
                            <p>'
                            .$entrega[0]['DSENDEPED'].', '.$entrega[0]['NMMUNIPED'].'<br>'
                            .$entrega[0]['SGESTADOPED'].' - '.$entrega[0]['NMPAISPED'].'<br> CEP: '
                            .$entrega[0]['NRCEPPED'].'</p>

                        </div>
                    </div>';
            
            
            return $html;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public static function getAspUrlParameter() {
        return InstanceManager::getInstance()->getParameter('aspUrl');
    }
    
    public static function getDelphiCryptoUncripto($password, $isEncrypt = true) {
        $url = self::getAspUrlParameter() . '/comwebservice/service.asmx?wsdl';
        
        $options = array(
            'encoding'    => 'ISO-8859-1',
            'trace'       => true,
            'exceptions'  => true,
            'compression' => SOAP_COMPRESSION_ACCEPT | SOAP_COMPRESSION_GZIP,
        );

        $args = array(
            new \SoapVar($password, XSD_STRING, 'string', "http://www.w3.org/2001/XMLSchema"),
            new \SoapVar('2', XSD_STRING, 'string', "http://www.w3.org/2001/XMLSchema") // chave (salt)
        );
        //2
        $cryptType = $isEncrypt ? 'GetCripto' : 'GetUnCripto';
        $params = array(
            'rdm'    => 'Bib.rdmDBGeral',
            'method' => $cryptType,
            'args'   => $args,
        );
            
        try {
            $client = new \SoapClient($url, $options);
            $result = $client->executeCOMMethod($params);
            $encryption = $result->executeCOMMethodResult;
        } catch (\SoapFault $e) {
            return 'SoapError';
        }

        return $encryption;
    }

    public function enviarEmail($request, $response) {
        
        try{
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
    
            foreach($rows as $pedido){
                
                $smtp = $this->getSmtp($pedido);
                
                if(empty($smtp)){
                    throw new \Exception('Dados de SMTP devem ser preenchidos na tela de Unidade!');
                }

                $entrega = $this->endEntregaPed($pedido);
                
                
                if(empty($entrega)){
                    throw new \Exception('Dados de endereço devem ser cadastrados na tela de Cliente!');
                }
                
                $itens = $this->tabelaItemPedido($pedido);
                $tabela = "";
                foreach($itens as $item){
                    $valorUnit = number_format($item['VRPREUNITPED'],2, ',', '.');
                    $qtd = number_format($item['QTITEMPED'],2, ',', '.');
                    $tabela.= 
                        '<tbody>
                            <tr style="font-size: 1rem;">
                              <td style="text-align:left;">' . $item['NMPRODUTO'] . '</td>
                              <td style="text-align:right;">' . $qtd  . '</td>
                              <td style="text-align:right;">R$ ' .$valorUnit.'</td>
                            </tr><br>
                        </tbody>';
                }
    
                $message = $this->mailBody($pedido, $itens, $tabela, $entrega);
                
                $mail = new PHPMailer;
                $mail->CharSet  = 'UTF-8';
                $mail->isSMTP();
                $mail->isHTML();
                $mail->SMTPAuth = true;

                // DADOS DE AUTENTICAÇÃO COM SMTP
                $mail->Host     = $smtp[0]['DSSMTPEMAILF'];
                $mail->Username = $smtp[0]['DSLOGINSMTP'];
                $mail->Password = $this->getDelphiCryptoUncripto($smtp[0]['CDSENHEMAILF'], false);;
                $mail->From     = $smtp[0]['DSLOGINSMTP'];
                $mail->FromName = 'Confirmação de Pedido Nº#'.$pedido['NRPEDIDO'];
               
                $email = $pedido['DSEMAILCLIENFE'];
                $subject = 'Confirmação de Pedido';
                
                $mail->addAddress($email);
                $mail->Subject = $subject;
                $mail->Body = $message;
                $mail->send();
            }
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
            throw $e;
        }
        
        // $vendedor = $rows[4];
        // $idx = 0;
        // $erros = array();
        // foreach ($rows[0] as $key => $pedido) {
        //     $cliente = array();
        //     $prazos = array();
        //     $produtos = array();
        //     $filial = array();
        //     $dadosPedido = $rows[0][$key];
        //     for ($e =0; $e < count($rows[1]); $e++) {
        //         if ($rows[0][$key]['NRPEDIDO'] == $rows[1][$e]['NRPEDIDO']) {
        //             array_push($prazos, $rows[1][$e]);
        //         }
        //     }
        //     for ($e =0; $e < count($rows[2]); $e++) {
        //         if ($rows[0][$key]['NRPEDIDO'] == $rows[2][$e]['NRPEDIDO']) {
        //             array_push($produtos, $rows[2][$e]);
        //         }
        //     }
        //     for ($e =0; $e < count($rows[3]); $e++) {
        //         if ($rows[0][$key]['CDCLIENTE'] == $rows[3][$e]['CDCLIENTE']) {
        //             $cliente = $rows[3][$e];
        //         }
        //     }
        //     for ($e =0; $e < count($rows[5]); $e++) {
        //         if ($rows[0][$key]['CDFILIAL'] == $rows[5][$e]['CDFILIAL']) {
        //             $filial =  $rows[5][$e];
        //         }
        //     }
        //     $email = isset($cliente['DSEMAILCLIE']) > 0 && strlen($cliente['DSEMAILCLIE']) > 0 ? $cliente['DSEMAILCLIE'] : '';
        //     // $email = $cliente['DSEMAILCLIE'] ;

        //     $pattern = '/^[a-zA-Z0-9\.]+@([a-z]+\.)+[a-z]{2,4}$/';
        //     preg_match($pattern, $email, $matches);
        //     if (count($matches)) {
        //         $subject    = 'Detalhamento do Pedido';
        //         $message = $this->buildMessage($subject, $dadosPedido, $prazos, $produtos, $cliente, $vendedor, $filial);
        //         $mail = new PHPMailer;
        //         $mail->CharSet = 'UTF-8';
        //         $mail->isSMTP();                        // Set mailer to use SMTP
        //         $mail->isHTML();
        //         $mail->Host = 'smtp.teknisa.com';       // Specify main and backup SMTP servers
        //         $mail->SMTPAuth = true;                 // Enable SMTP authentication
        //         $mail->Username = 'app@tecfood.com';    // SMTP username
        //         $mail->Password = '@AppTecFood2015';    // SMTP password
        //         $mail->From = 'app@tecfood.com';
        //         $mail->FromName = 'Pedido Mobile';
        //         // $mail->addAddress($cliente['DSEMAILCLIE']);
        //         // $mail->addAddress($vendedor['DSEMAILOPER']);
        //         $mail->addAddress('luiz.barcelos@teknisa.com');

        //         $mail->Subject = $subject;
        //         $mail->Body = $message;
        //         // $mail->send();
        //     } else {
        //         array_push($erros, $rows[0][$key]);
        //         $idx++;
        //     }
        // }
        // if (count($erros) > 0) {
        //     // $erros = implode(", ", $erros);
        //     $response->setError(new DTO\Response\Error($erros, 1));
        // }
    }

    public function deletarPrazo($request, $response) {
        $this->dataSourceName = 'prazopgtoped';
        $data = $request->getDataSet();
        $rows = $data->getRows();
		
        for($i = 0; $i < count($rows); $i++) {
            try {
                $dataSet = new DataSet ("data", array($rows[$i]));
                $requestDel = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                parent::delete($requestDel, $response);
            } catch (\Exception $e) {
                if((strlen($response->getError()) > 0)){
                    $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
                    throw $e;
                }
            }
        }
    }

    public function buildMessage($subject, $dadosPedido, $prazos, $produtos, $cliente, $vendedor, $filial) {
        if (empty($filial['NMRAZSOCEMPR'])) {
            $filial['NMRAZSOCEMPR'] = $filial['NMFILIAL'];
        }

        $message = file_get_contents(__DIR__ . "/../../../../../../templates/mail_template.html");
        $message = str_replace('MAIL_TITULO', $subject, $message);
        $message = str_replace('MAIL_NOME_FILIAL', $filial['NMRAZSOCEMPR'], $message);
        $message = str_replace('MAIL_NOME_CLIENTE', $cliente['NMFANTCLIE'], $message);
        $message = str_replace('MAIL_ENDERECO_CLIENTE', $cliente['DSENDECLIE'], $message);
        $message = str_replace('MAIL_BAIRRO_CLIENTE', $cliente['NMBAIRCLIE'], $message);
        $message = str_replace('MAIL_CEP_CLIENTE', $cliente['NRCEPCLIE'], $message);
        $message = str_replace('MAIL_TABELA_PRODUTO', $this->retornaTabelaProdutos($produtos), $message);
        $message = str_replace('MAIL_PAGAMENTOS', $this->retornaTabelaPagamentos($prazos), $message);
        $message = str_replace('MAIL_PAGAMENTO_TOTAL', $dadosPedido['VRTOTALPED'], $message);
        $message = str_replace('MAIL_NOME_VENDEDOR', $vendedor['NMFANVEN'], $message);
        $message = str_replace('MAIL_EMAIL_VENDEDOR', $vendedor['DSEMAILOPER'], $message);
        $message = str_replace('MAIL_ENDERECO_FILIAL', 'Rua '.$filial['DSENDEFILI'].' - '.$filial['NMBAIRFILI'], $message);
        return $message;
    }

    public function retornaTabelaProdutos($produtos) {
        $tabelaProdutos = "";
        foreach ($produtos as $produto) {
            $tabelaProdutos .= '

  <tbody>
    <tr>
      <td>' . $produto['NMPRODUTO'] . '</td>
      <td>' . $produto['QTITEMPED'] . '</td>
      <td>' . $produto['VRPREUNITPED'] . '</td>
      <td>' . $produto['VRTOTALITEM'] . '</td>
    </tr>
  </tbody>';
        }
        return $tabelaProdutos;
    }

    public function retornaTabelaPagamentos($pagamentos) {
        $tabelaPagamentos = "";
        foreach ($pagamentos as $pagamento) {
            $tabelaPagamentos .= '<tr style="height: 23px;">
            <td style="border: 1px solid #ccc; width: 15%; height: 23px; padding-left:5px;">' . $pagamento['PREVISAO'] . '</td>
            <td style="border: 1px solid #ccc; width: 88%; height: 23px;padding-left:5px;">' . $pagamento['VRPARCELA'] . '</td>
            </tr>';
        }
        return $tabelaPagamentos;
    }
    
    public function calculaImposto($request, $response) {
        try {
            $this->entityManager->beginTransaction();
            $data = $request->getDataSet()->getRows();
            $encargos = $data[1][0];
            $itens = $data[0];
            $pedido = $data[2];
            $pedido['CDFILIALPED'] = null;

            $idmobile = 'S';
            
            $this->insereItemtrab($itens, $pedido, $request, $response, $idmobile);
            $this->saveEncargotrab($encargos);
            
            $impostos = $this->pedidosService->getImpitempedidotrab($pedido);
            
            $this->atualizaItens($itens, $impostos);
            
            if (count($itens) > 0) {
                $this->pedidosService->deleteItemtrab($pedido, $response);
            }
            if (count($encargos) > 0) {
                $this->pedidosService->deleteEncargotrab($pedido, $response);
            }
            $this->pedidosService->deleteImpitempedidotrab($pedido, $response);
            
            $itens = array($itens);
            $itens = new DataSet ("itens", $itens);
            $response->addDataSet($itens);
            $this->entityManager->commit();
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            $this->entityManager->rollback();
        }
    }
    
    public function atualizaItens($itens, $impostos) {
        for ($i = 0; $i < count($itens); $i++) {
            for ($e = 0; $e < count($impostos); $e++) {
                if ($itens[$i]['NRPEDIDO'] == $impostos[$e]['NRPEDIDO'] && $itens[$i]['NRITEMPED'] == $impostos[$e]['NRITEMPED']) {
                    $itens[$i]['VRTOTALITEM'] = $itens[$i]['VRTOTALITEMSEMIMP'] + $impostos[$e]['VRIMPOSTOITPED'];
                }
            }
        }
    }
    
    public function insereItemtrab($itens, $pedido, $request, $response, $idmobile) {
        foreach ($itens as $item) {
            $itemTrab = array ();
            $itemTrab['CDFILIAL']       = $pedido['CDFILIAL'];
            $itemTrab['NRPEDIDO']       = $pedido['NRPEDIDO'];
            $itemTrab['NRITEMPED']      = $item['NRITEMPED'];
            $itemTrab['DTENTITPED']     = $pedido['DTENTITPED'];
            $itemTrab['CDPRODUTO']      = $item['CDPRODUTO'];
            $itemTrab['QTITEMPED']      = $item['QTITEMPED'];
            $itemTrab['VRPREUNITPED']   = $item['VRPREUNITPED'];
            $itemTrab['VRDESITPED']     = $item['VRDESITPED'];
            $itemTrab['NRORG']          = $pedido['NRORG'];
            
            $this->pedidosService->insereItemtrab($itemTrab, $response);
        }
        foreach ($itens as $item) {
            $item['CDFILIAL'] = $pedido['CDFILIAL'];
            $this->pedidosService->getImpostoItem($pedido, $item, $request, $response, $idmobile);
        }
    }
    
    public function saveEncargotrab($encargos) {
        if(count($encargos) > 0){
            foreach ($encargos as $encargo) {
                $this->pedidosService->saveEncargotrab($encargo);
            }
        }
    }
    
    public function deletePedido($request, $response){
        $data = $request->getDataSet();
        $rows = $data->getRows();
        
        $params = array(
            'P_NRPEDIDO' => $rows[0]['NRPEDIDO'],
            'P_CDFILIAL' => $rows[0]['CDFILIAL']
        );
        
        $this->pedidosService->deletePedido($params);
    }
    
    public function validaQtdeDispEstoque($request, $response) {
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        
        $cdfilial = $rows[0]['CDFILIAL'];
        $cdtipooper = $rows[1]['CDTIPOOPER'];
        $itens = $rows[2]['itens'];
        $erro = 9;
        
        try {
            
            // busca paramfilial
            $paramfilial = $this->getParamFilial($cdfilial);
            // verifica se filial controla estoque
            if($paramfilial['IDCTRLESTQ'] == 'S'){
                
                // busca tipooperac
                $tipooperac = $this->getTipoOperac($cdtipooper);
                // verifica se tipo de operação atualiza estoque
                if($tipooperac['IDATUESTTPOP'] == 'S'){
                    
                    $prodComErro = array();
                    // loop nos itens verificando se os produtos controlam estoque
                    foreach($itens as $item){
                        // verifica se o produto controla estoque
                        $prodContrEst = $this->pedidosService->verificaProdutoContEst($cdfilial, $item['CDPRODUTO']);
                        if(!empty($prodContrEst) && $prodContrEst[0]['IDCNTRESTOQ'] == 'S'){
                            
                            // busca parampedido
                            $parampedido = $this->getParampedido($cdfilial);
                            
                            // busca quantidade disponível real
                            $qtdeDisponivel = $this->qtdeDisponivel($cdfilial,
                                                                    $item['CDPRODUTO'],
                                                                    $item['CDPRODESTO'],
                                                                    $paramfilial['IDCTRLDISTRIB'] ?? 'N',
                                                                    $paramfilial['IDUTILALMOX'],
                                                                    $parampedido);
                            
                            $exQtDisp = $qtdeDisponivel[0];
                            $exQtItem = $item['QTITEMPED'] * $item['VRFATOCONV'];
                            $exQtSaldTotalEst = $qtdeDisponivel[1];
                            
                            if($parampedido['IDTESTAEST'] == '2'){
                                if($exQtItem > $exQtDisp){
                                    $prod = array('CDARVPROD'       => $item['CDARVPROD'],
                                                'NMPRODUTO'         => $item['NMPRODUTO'],
                                                'EXQTDISP'          => $exQtDisp,
                                                // 'exQtSaldTotalEst'  => $exQtSaldTotalEst,
                                                'EXQTITEM'          => $exQtItem,
                                                'EXQTDIFF'          => $exQtDisp - $exQtItem);
                                                        
                                    array_push($prodComErro, $prod);
                                }
                            }
                        }
                    }
                    
                    if(!empty($prodComErro)){
                        $response->addDataSet(new DataSet('validaQtdeDispEstoque', ['erro' => 1, $prodComErro]));
                    }else{
                        $response->addDataSet(new DataSet('validaQtdeDispEstoque', ['erro' => 0]));
                    }
                    
                }else{
                    // se tipo de operação nao atualiza estoque
                    $response->addDataSet(new DataSet('validaQtdeDispEstoque', ['erro' => 0]));
                }
            }else{
                // se filial não controla estoque
                $response->addDataSet(new DataSet('validaQtdeDispEstoque', ['erro' => 0]));
            }
            
        } catch (\Exception $e) {
            // $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            // $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function getParamFilial($cdfilial){
        $filter = array(
            array(
                "columnName" => "CDFILIAL",
                "operator" => "=",
                "value" => $cdfilial
            )
        );
        $paramfilial = new DTO\Response();
        $filterCriteria = new FilterCriteria('paramfilial', $filter);
        $this->crudService->find($paramfilial, $filterCriteria);
        $paramfilial = $paramfilial->getDataSets()[0]->getRows()[0];
        
        return $paramfilial;
    }
    
    public function getTipoOperac($cdtipooper){
        $filter = array(
            array(
                "columnName" => "CDTIPOOPER",
                "operator" => "=",
                "value" => $cdtipooper
            ),
            array(
                "columnName" => "IDENTRSAIDOP",
                "operator" => "=",
                "value" => 'S'
            )
        );
        $tipooperac = new DTO\Response();
        $filterCriteria = new FilterCriteria('tipooperac', $filter);
        $this->crudService->find($tipooperac, $filterCriteria);
        $tipooperac = $tipooperac->getDataSets()[0]->getRows()[0];
        
        return $tipooperac;
    }
    
    public function getParampedido($cdfilial){
        $filter = array(
            array(
                "columnName" => "CDFILIAL",
                "operator" => "=",
                "value" => $cdfilial
            )
        );
        $parampedido = new DTO\Response();
        $filterCriteria = new FilterCriteria('parampedido', $filter);
        $this->crudService->find($parampedido, $filterCriteria);
        $parampedido = $parampedido->getDataSets()[0]->getRows()[0];
        
        return $parampedido;
    }
    
    public function qtdeDisponivel($cdfilial, $cdproduto, $cdprodesto, $idctrldistrib, $idutilalmox, $parampedido){
        // busca quantidade disponível considerando pedidos já lançados 
        $qtDispQtPed = $this->pedidosService->getQtDispQtPed($cdfilial, $cdproduto);
        
        // busca quantidade disponível real
        $qtdeDisponivel = $this->pedidosService->qtdeDisponivel($cdfilial, $cdprodesto, $idctrldistrib, $idutilalmox);
        
        $exQtEst = $qtdeDisponivel[0]['QTTOTALESTOQ'];
        if($exQtEst > 0)
            $exQtEst = $exQtEst - $qtDispQtPed[0]['QTITEMPEDEXP'];
        else
            $exQtEst = 0;
            
        $exQtTot = $qtdeDisponivel[0]['QTTOTALESTOQ'];
        
        $retorno[0] = $exQtEst;
        $retorno[1] = $exQtTot;
        
        return $retorno;
    }
    
    public function salvarDuplicPed(DTO\Request $request, DTO\Response $response){
        $dataSet = $request->getDataSet();
        $row = $dataSet->getRows();

        $pedido   = $row[0]['pedido'];
        $cdoperador = $row[1]['operador'];
        $filial = $pedido['CDFILIAL'];
        
        // gera o numero do novo pedido 
        $prxPedido= new Row ();
        $prxPedido->set('NOVOCODIGO', $this->newCode->getCodeByTableName('PEDIDO'.$filial, $this->environment->getNrOrgTrab()));
        // chama a procedure REPLICA_PEDIDO e retorna  o erro  caso exista
        $cdMensErro = $this->pedidosService->replicaPedido($pedido, $prxPedido, $cdoperador);

        $response-> addDataSet(new DataSet('codigo', $cdMensErro));
        
        /*try{
            $paramped = $this->pedidosService->getParamsPed($filial);//busca os parametros do pedido da filial
            
            //gera o próximo nrpedido para o novo pedido 
            $prxPedido= new Row ();
            $prxPedido->set('NOVOCODIGO', $this->newCode->getCodeByTableName('PEDIDO'.$filial, $this->environment->getNrOrgTrab()));
            
            $boErroPedido = false;
            //chama procedure que  valida a replicação do pedido 
             
            $cdMensErro = 'OK';

            if($cdMensErro == 'OK'){

                $TabPrecoPedNovo = $this->pedidosService->getTabPrecoNovo($filial, $prxPedido);
                $itemPedOrig = $this->pedidosService->getItemDuplicaPed($filial, $nrpedido);
                $pedidoInd = $this->pedidosService->getPedidoInd($filial, $nrpedido);

                foreach ($itemPedOrig as $item){
                    
                    $cdarvprod = $item['CDARVPROD'];
                    $iditpeddifer = 'T';
                    $precoBase = $this->pedidosService->getPrecoBase($pedido, $cdarvprod,$iditpeddifer);
                    
                    if($paramped[0]['IDTABPRECO'] == '1'){
                        
                        $vrpreunitped = $precoBase[0]['VRITEPREBASE'];
                        $cdfatpreco = "";
                    }else{
                        $vrpreunitped ="";
                        $cdfatpreco = $item['CDFATPRECO'];
                        
                    }
                    //chama a procedure que grava os itens do novo pedido
                    $gravaItemPedNovo = $this->pedidosService->gravaItemPedNovo($pedido, $prxPedido, $item, $vrpreunitped, $cdfatpreco); 

                    $newNrItemPed = '0000000001';//$gravaItemPedNovo['NRITEMPED'];
                    $iditpeddifer = $precoBase[0]['IDITPEDDIFER'];
                    //$this->pedidosService->updtTipoPreco($filial, $prxPedido, $newNrItemPed, $iditpeddifer); 

                    $nritemped = $item['NRITEMPED'];
                    
                    $compItemPed = $this->pedidosService->CompItemPed($filial, $nrpedido, $nritemped);

                    if(!empty($compItemPed)){
                        foreach($compItemPed as $compIt){
                            $this->pedidosService->insereComp($filial, $prxPedido, $newNrItemPed, $compIt); 
                        }
                    }
                    $calcItemPeso = $this->pedidosService->calculaPesoBruLiq($filial, $nrpedido);

                    $this->pedidosService->updatePeso($filial, $prxPedido, $vrpbruvolped, $vrpliqvolped);
                    
                    $cderroGravaItem = 'OK';//$gravaItemPedNovo['CDMENSERRO'];
                    
                    //Tratativa de erros
                    $erros = array();
                    if($cderroGravaItem != 'OK'){
                        foreach($cderroGravaItem as $cdErro){
                            array_push($erros,$cdErro );
                        }
                    }
                    
                
                    //Tratativa sucesso
                    if($cderroGravaItem == 'OK'){
                        
                        if($paramped[0]['IDUTRESELOTE'] == 'S'){
                            
                            $this->pedidosService->reservaPedDup($item);
                        }
                        $calcTotImpos = $this->pedidosService->calcTotImpos($filial, $prxPedido);
                        
                        
                        foreach($calcTotImpos as $cTI){
                            $consImposPedTot = $this->pedidosService->consImposPedTot($cTI);

                            if(empty($consImposPedTot)){
                                $this->pedidosServiço->insItemPedTot($cTI);
                            }else{
                              $this->pedidosService->updItemPedTot($cTI);
                            }
                        }
                        
                        if($pedidoInd[0]['IDPEDINDUSTRIA'] == 'S'){
                            $cdproduto = 'T';
                            $tercProduto = $this->pedidoService->tercProduto($filial, $nrpedido, $nritemped, $cdproduto);
                            
                            foreach($tercProduto as $tProd){
                                $itensPed = $this->pedidosService->getItemDuplicaPed($filial, $prxPedido);
                                foreach($itensPed as $itPed){
                                    $this->pedidosService->insTercProduto($fiflial, $prxPedido, $tProd, $itPed);
                                    
                                    $this->pedidosService->upItemPedTerc($item, $itPed, $filial, $prxPedido);
                                }
                                
                            }
                        }
                       
                    }
                }
                
            }else{
                $result = $cdMensErro;
                $boErroPedido = true;
            }
            
            if($boErroPedido == false and $cdMensErro = 'OK'){
                 
                if($paramped[0]['IDLANENCARGOPED'] == 'S'){

                    $encargoPed = $this->pedidosService->getEncargosPed($filial, $nrpedido);
                    
                    if(!empty($encargoPed)){
                        
                        foreach($encargoPed as $encargo){
                            
                            if($encargo['VRENCARGOPED'] > 0){
                                $this->pedidosService->insEncargoPed($filial, $prxPedido, $encargo);
                            }
                        }
                    }
                }
                
                $impostoEncar= $this->pedidosService->imposEncargo($filial, $prxPedido);
                $modPedido = $this->pedidosService->modPgtoPedido($filial, $prxPedido);
                
                $cdModPgto = $modPedido[0]['CDMODPGTO'];
                
                $prazosPed = $this->pedidosService->prazosModPgto($cdModPgto);
                
                
                if(!(empty($prazosPed ))){
                    foreach($prazosPed as $prazo){
                        $vrparcela = round((($impostoEncar['VRTOTAL'] * $prazo['VRPERCMODPGTO'])/100), 2);
                        $this->pedidosService->insPrazoPgto($filial, $prxPedido, $prazo, $vrparcela);
                    }
                    //getPrazoPgto
                    $somaPrazoPed = $this->pedidoService->somaPrazoPgto($filial, $prxPedido);
                    $parc = $impostoEncar['VRTOTAL'] - $somaPrazoPed['VRPARCELATOT'];
                    if($parc >0){
                        $parcMax = $this->pedidosService->maxParcela($filial, $prxPedido);
                        
                        $vrparcela = $parcMax['VRPARCELA'] + $parc; 
                        $this->pedidosService->updtPrazoPgto($parcMax, $vrparcela);
                    }
                }
                
                //Busca observação do pedido origem e salva no novo pedido 
                $observPed = $this->pedidosService->observacaoPed($filial, $nrpedido);
                if(!empty($observPed)){
                  foreach($observPed as $obs){
                     $this->pedidosService->insereObservacaoPed($filial, $prxPedido, $obs);
                  }  
                }

                //Busca dados adicionais do pedido origem e salva no novo pedido 
                $dadosAdicPed = $this->pedidosService->dadosAdicPed($filial, $nrpedido);
                if(!empty($dadosAdicPed)){
                    $this->pedidosService->insereDadosAdicPed($filial, $prxPedido, $dadosAdicPed);
                }
                
            }
            
            if(!($boErroPedido)){
                if($cdMensErro != 'OK'){
                    
                }
            }
        }catch(\Exception $e){
            
        }*/

    } 
    
}