/******************************************************************************/
/* SITE - Sistemas Integrados TECNISA                                         */
/******************************************************************************/
/* Nome:      8651_VMNSTP_GeraSolicTroco                                      */
/* Descrio: Gera a Solicitado de Troco.                                   */
/* Criao:   25/01/2003 - Renata Diniz                                       */
/******************************************************************************/
/* raise_application_error(-20501, '' , True);                                */
/* @C:\Win_Prj\Sql\End_Conv\Oracle\8651_VMNSTP_GeraSolicTroco.SQL             */
/******************************************************************************/
CREATE OR REPLACE PROCEDURE GERA_SOLICTROCO
 (
   P_CDFILIAL      IN SOLICTROCO.CDFILIAL%TYPE,
   P_NRSOLICTROCO  IN SOLICTROCO.NRSOLICTROCO%TYPE,
   P_DTSOLICTROCO  IN SOLICTROCO.DTSOLICTROCO%TYPE,
   P_CDROTATRANS   IN SOLICTROCO.CDROTATRANS%TYPE,
   P_NRMAPABASEV   IN SOLICTROCO.NRMAPABASEV%TYPE,
   P_CDMOEDEIRO    IN MOEDEIRO.CDMOEDEIRO%TYPE
 )

IS
   V_VRMINABAMOED  NUMBER;
   V_VRMAXABAMOED  NUMBER;
   V_QTDEMIN       NUMBER;
   V_QTDEMAX       NUMBER;
   V_INSERE        VARCHAR(1);
   V_CONT          NUMBER;
   V_QTDE          NUMBER;
   V_NRMAPAANT     VARCHAR2(10);
   V_CDEQUIPPRO    VARCHAR2(10);

BEGIN

   V_CONT := 0;

   INSERT INTO SOLICTROCO
   (CDFILIAL, NRSOLICTROCO, DTSOLICTROCO, CDROTATRANS,
    NRMAPABASEV)
   VALUES
   (P_CDFILIAL, P_NRSOLICTROCO, P_DTSOLICTROCO, P_CDROTATRANS,
    P_NRMAPABASEV);

   /* qryMinMax */
   SELECT
      NVL(MAX(VRMINABAMOED),0), NVL(MAX(VRMAXABAMOED),0)
   INTO V_VRMINABAMOED, V_VRMAXABAMOED
   FROM
      MOEDEIRO
   WHERE
      (CDMOEDEIRO = P_CDMOEDEIRO);
   
   SELECT CDEQUIPPRO
   INTO V_CDEQUIPPRO
   FROM MAPABASEV
   WHERE CDFILIAL    = P_CDFILIAL AND
         NRMAPABASEV = P_NRMAPABASEV;

   SELECT NVL(MAX(NRMAPABASEV), '0')
   INTO V_NRMAPAANT
   FROM MAPABASEV
   WHERE CDEQUIPPRO = V_CDEQUIPPRO;

   /* Verifica Mnimo */
   FOR CUR_TROCO IN (
      SELECT
         CDNUMERARIO, QTSALDTROCMA
      FROM
         TROCOMAPABAS
      WHERE
         (CDFILIAL    = P_CDFILIAL   ) AND
         (NRMAPABASEV = V_NRMAPAANT) ) LOOP

      /* qryBuscaQtdeMin */
      SELECT
         A.QTNUMERAMOED, B.QTNUMERAMOED
      INTO V_QTDEMIN, V_QTDEMAX
      FROM
         PERNUMERARIO A, PERNUMERARIO B
      WHERE
         (A.CDMOEDEIRO   = P_CDMOEDEIRO         ) AND
         (A.CDNUMERARIO  = CUR_TROCO.CDNUMERARIO) AND
         (A.VRPENUMEMOED = V_VRMINABAMOED       ) AND
         (B.CDMOEDEIRO   = P_CDMOEDEIRO         ) AND
         (B.CDNUMERARIO  = CUR_TROCO.CDNUMERARIO) AND
         (B.VRPENUMEMOED = V_VRMAXABAMOED       );


      IF CUR_TROCO.QTSALDTROCMA < V_QTDEMIN THEN
         V_INSERE := 'T';
         EXIT;
      END IF;
   END LOOP;

   FOR CUR_TROCO IN (
      SELECT
         CDNUMERARIO, QTSALDTROCMA
      FROM
         TROCOMAPABAS
      WHERE
         (CDFILIAL    = P_CDFILIAL   ) AND
         (NRMAPABASEV = V_NRMAPAANT) ) LOOP

      /* qryBuscaQtdeMin */
      SELECT
         A.QTNUMERAMOED, B.QTNUMERAMOED
      INTO V_QTDEMIN, V_QTDEMAX
      FROM
         PERNUMERARIO A, PERNUMERARIO B
      WHERE
         (A.CDMOEDEIRO   = P_CDMOEDEIRO         ) AND
         (A.CDNUMERARIO  = CUR_TROCO.CDNUMERARIO) AND
         (A.VRPENUMEMOED = V_VRMINABAMOED       ) AND
         (B.CDMOEDEIRO   = P_CDMOEDEIRO         ) AND
         (B.CDNUMERARIO  = CUR_TROCO.CDNUMERARIO) AND
         (B.VRPENUMEMOED = V_VRMAXABAMOED       );


      IF (CUR_TROCO.QTSALDTROCMA < V_QTDEMIN) OR (V_INSERE = 'T') THEN

         V_CONT := V_CONT + 1;
         V_QTDE := V_QTDEMAX - CUR_TROCO.QTSALDTROCMA;

         INSERT INTO NUMESOLTROCO
           (CDFILIAL, NRSOLICTROCO, CDNUMERARIO, QTPREVSTROCO,
            QTSOLICTROCO)
         VALUES
           (P_CDFILIAL, P_NRSOLICTROCO, CUR_TROCO.CDNUMERARIO,
            V_QTDE, V_QTDE);
      END IF;
   END LOOP;

   IF V_CONT = 0 THEN
      FOR CUR_MOEDEIRO IN (
          SELECT CDNUMERARIO
          FROM NUMEMOEDEIRO
          WHERE CDMOEDEIRO = P_CDMOEDEIRO ) LOOP

         SELECT
            NVL(MAX(B.QTNUMERAMOED), 0)
         INTO V_QTDEMAX
         FROM
            PERNUMERARIO B
         WHERE
            (B.CDMOEDEIRO   = P_CDMOEDEIRO  ) AND
            (B.CDNUMERARIO  = CUR_MOEDEIRO.CDNUMERARIO ) AND
            (B.VRPENUMEMOED = (SELECT NVL(MAX(VRPENUMEMOED),0)
                               FROM  PERNUMERARIO
                               WHERE (CDMOEDEIRO   = P_CDMOEDEIRO  ) AND
                                     (CDNUMERARIO  = CUR_MOEDEIRO.CDNUMERARIO)));

         INSERT INTO NUMESOLTROCO
           (CDFILIAL, NRSOLICTROCO, CDNUMERARIO, QTPREVSTROCO,
            QTSOLICTROCO)
         VALUES
           (P_CDFILIAL, P_NRSOLICTROCO, CUR_MOEDEIRO.CDNUMERARIO,
            V_QTDEMAX, V_QTDEMAX);
      END LOOP;
   END IF;
END;
/
