var  ped05900_composicao_preco_produto_Controller = function(ScreenService, General,templateManager, ZHPromise, restEngine, ZhFilterPreferences, MessageService){
                                                            
    this.valor = '';
    let ehNovo = true;
    
    this.startFiltering = function(widget){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter(widget);
        }.bind(this)); 
    };
    
    this.setFilter = function(widget) {
        var filterRow = {};
        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            filterRow.CDFILIAL = response.dataset.filial[0].CDFILIAL;
            filterRow.NMFILIAL = response.dataset.filial[0].NMFILIAL;
            templateManager.container.getActiveWidget().currentRow = filterRow;
        }.bind(this));
    };

    
    this.setDefaultTab = function(){
        var widget = templateManager.container.getWidget('widgetComposicao');
        widget.activate();
        widget.reload();
    };
    
    this.setDefaultValue = function(widget){
        widget.getField('NMITFORPRECO').readOnly = false;
        widget.getField('VRPEFORMPREC').readOnly = false;
        widget.getField('VRFATFORMPREC').readOnly = false;
        widget.getField('VRPEFORMPREC').setValue('0');
        widget.getField('VRFATFORMPREC').setValue('0');

    };
    this.editCompPreco = function(widget){
        widget.getField('VRPEFORMPREC').readOnly = false;
        widget.getField('VRFATFORMPREC').readOnly = false;
        widget.getField('NMITFORPRECO').readOnly = true;
        General.edit(widget);
    };
    
    this.disableField = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.VRPEFORMPREC != 0 && widget.currentRow.VRFATFORMPREC == 0 ){
            if(widget.currentRow.VRPEFORMPREC > 100){
                ScreenService.showMessage('O Percentual de Composição do Preço do Produto não pode ser maior que 100.');
                widget.getField('VRPEFORMPREC'). setValue('0');
            }else{
                widget.getField('VRFATFORMPREC').readOnly = true;
            }
        }else if (widget.currentRow.VRFATFORMPREC != 0 && widget.currentRow.VRPEFORMPREC == 0){
            widget.getField('VRPEFORMPREC').readOnly = true;
        }
    };
    
    this.openPopupformulaCalcPreco = function(){
        var widgetFormCalc = templateManager.container.getWidget('widgetFormCalc');
        
        widgetFormCalc.activate();
        widgetFormCalc.reload();
        
        //templateManager.container.getWidget('widgetFormula').getField('DSFORMCALCPRECO').setValue(this.valor);
        
        ScreenService.openPopup(widgetFormCalc);
    };
    this.closePopupFormula = function(){
        var widgetComposicao = templateManager.container.getWidget('widgetComposicao');
        var widgetFormula = templateManager.container.getWidget('widgetFormula');
        var fieldsForm = widgetFormula.fields;
        var field = [];
        
        fieldsForm.forEach(function(f){
            if(f.name != 'DSFORMCALCPRECO' || f.name !='BUTTON_DEFAULT'){
                
                fieldsForm.pop(field);
            }
        });

        ScreenService.closePopup();
        widgetComposicao.activate();
        widgetComposicao.reload();
        templateManager.updateTemplate();
    };
    
    this.setDataSourceFilterApply = function(args){
        var widgetProduto = templateManager.container.getWidget('widgetProduto');
         if(templateManager.container.getActiveWidget().isValid()){
            var rowPopup = templateManager.container.getActiveWidget().currentRow;
            var dataSourceFilter= [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": rowPopup.CDFILIAL
                }
            ];
            
            widgetProduto.dataSourceFilter = dataSourceFilter;
            widgetProduto.currentRow.CDTIPOCUSTO = rowPopup.CDTIPOCUSTO;
            widgetProduto.currentRow.CDFILIAL = rowPopup.CDFILIAL;
            widgetProduto.reload();
         }
    };
    
    this.openWindowCalculo= function(){
        
        var widgetProduto = templateManager.containers['ped_pedidos#ped05900_composicao_preco_produto'].getWidget('widgetProduto');
        var tipoCusto = widgetProduto.currentRow.CDTIPOCUSTO;
        var filial = widgetProduto.currentRow.CDFILIAL;
        widgetProduto.deactivate();
        widgetProduto.isVisible = false;
         
        ScreenService.openWindow('ped_pedidos#ped05900_composicao_preco_produto_calc').then(function(){
            var widgetCalculoPreco = templateManager.containers['ped_pedidos#ped05900_composicao_preco_produto_calc'].getWidget('widgetCalculo');
            widgetCalculoPreco.activate();
            widgetCalculoPreco.isVisible = true;
            
            widgetCalculoPreco.getField('IDTPCALCPREBASE').setValue('T');
            widgetCalculoPreco.currentRow.IDTPCALCPREBASE = "T";
            widgetCalculoPreco.currentRow.DTVALICALC = moment().format('DD/MM/YYYY');
            widgetCalculoPreco.getField('TTCDPRODUTO').setValue('I');
            widgetCalculoPreco.currentRow.TTCDPRODUTO = "I";
            widgetCalculoPreco.currentRow.CDTIPOCUSTO = tipoCusto;
            widgetCalculoPreco.currentRow.CDFILIAL = filial;

        });
    };
    this.closeWindowCalculo = function(){
        var widgetCalculo = templateManager.container.getWidget('widgetCalculo');
        var widgetListaCalc = templateManager.container.getWidget('listaCalcPreco');
        
        widgetCalculo.getField('NMPRODINI').clearValue();
        widgetCalculo.getField('NMPRODFIN').clearValue();
        widgetCalculo.currentRow.CDPRODUTOINI = "";
        widgetCalculo.currentRow.CDPRODUTOFIN = "";
        
        widgetCalculo.isVisible = false;
        widgetCalculo.deactivate();
        widgetListaCalc.dataSourceFilter = [];
        widgetCalculo.reload();
        
        ScreenService.openWindow('ped_pedidos#ped05900_composicao_preco_produto').then(function(){
            
            var widgetProduto = templateManager.container.getWidget('widgetProduto');
            widgetProduto.isVisible = true;
            widgetProduto.activate();
            this.setDataSourceFilterApply();
            widgetProduto.reload();
        }.bind(this));
    };
    this.enableField = function(){
       var widgetCalculo = templateManager.containers['ped_pedidos#ped05900_composicao_preco_produto_calc'].getWidget('widgetCalculo');
       if(widgetCalculo.currentRow.IDTPCALCPREBASE == 'L'){
           widgetCalculo.getField('CDPRECOBASE').readOnlyOnEdit = false;
       }else{
           widgetCalculo.getField('CDPRECOBASE').readOnlyOnEdit = true;
       }
       
       if(widgetCalculo.currentRow.TTCDPRODUTO == 'I'){
           widgetCalculo.getField('NMPRODINI').readOnly = false;
           widgetCalculo.getField('NMPRODINI').validations = {required:true};
       }else{
           widgetCalculo.getField('NMPRODINI').readOnly = true;
           widgetCalculo.getField('NMPRODINI').validations = {};
           this.setDataSourceFilter();
       }
       
       if(widgetCalculo.currentRow.NMPRODINI){
            widgetCalculo.getField('NMPRODFIN').readOnly = false;
            widgetCalculo.getField('NMPRODFIN').validations = {required:true};
       }else{
           widgetCalculo.getField('NMPRODFIN').readOnly = true;
           widgetCalculo.getField('NMPRODFIN').validations = {};
           widgetCalculo.getField('NMPRODFIN').setValue("");
           widgetCalculo.currentRow.NMPRODFIN = "";
       }
    };
    
    this.setDataSourceFilter = function(){
        var widgetCalculo = templateManager.container.getWidget('widgetCalculo');
        var row = widgetCalculo.currentRow;
        var widgetListaCalc = templateManager.container.getWidget('listaCalcPreco');
        
        widgetListaCalc.dataSourceFilter = [];
        
        if(row.NMPRODFIN){
            if(row.P_CDPRODUTOINI > row.P_CDPRODUTOFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                widgetCalculo.getField('NMPRODFIN').setValue("");
                return 0;
            }
        }
        
        widgetListaCalc.dataSourceFilter.push(
            {
                name: "P_CDTIPOCUSTO",
                operator: "=",
                value: widgetCalculo.currentRow.CDTIPOCUSTO
            },
            {
                name: "P_CDFILIAL",
                operator: "=",
                value: widgetCalculo.currentRow.CDFILIAL
            }
        );
        
        if(widgetCalculo.currentRow.TTCDPRODUTO == 'I'){
            widgetListaCalc.dataSourceFilter.push(
                {
                    name: "P_CDARVPRODINI",
                    operator: "=",
                    value: widgetCalculo.currentRow.CDPRODUTOINI
                },
                {
                    name: "P_CDARVPRODFIN",
                    operator: "=",
                    value: widgetCalculo.currentRow.CDPRODUTOFIN
                },
                {
                    name:"P_TCDPRODUTO",
                    operator:"=",
                    value:"T"
                }
            );
        }else{
            widgetListaCalc.dataSourceFilter.push(
                {
                    name: "P_TTCDPRODUTO",
                    operator: "=",
                    value: widgetCalculo.currentRow.TTCDPRODUTO
                },
                {
                    name:"P_TCDPRODUTO",
                    operator:"=",
                    value:"T"
                }
            );
        }
        widgetListaCalc.reload();
    };
    
    this.createFields = function(){
        var widgetFormula = templateManager.container.getWidget('widgetFormula');
        var composicao = templateManager.container.getWidget('widgetComposicao').dataSource.data;
        var calculadora = templateManager.container.getWidget('widgetCalculadora');

        composicao.forEach(function(field){
            var newButtom = Object.assign({}, widgetFormula.getField('BUTTON_DEFAULT'));
            
            newButtom.name = field.SGITFORPRECO;
            newButtom.label = field.NMITFORPRECO;
            newButtom.isVisible = true;
            newButtom.showOnForm = true;
            newButtom.valueField = field.SGITFORPRECO; 
            newButtom.decriptionField = field.NMITFORPRECO;
            
            widgetFormula.fields.push(newButtom);
        });

        widgetFormula.activate();
        calculadora.activate();
        
        templateManager.updateTemplate();

    };
    
    this.disableButton = function (field){
        var widgetCalculadora = templateManager.container.getWidget('widgetCalculadora');
        field.readOnlyOnEdit = true;
        widgetCalculadora.reload();
    };
    
    this.atualizaDisplay = function (valor, widgetFormula, field){
        
        widgetFormula.currentRow.DSFORMCALCPRECO = valor;
        widgetFormula.getField('DSFORMCALCPRECO').setValue(valor);
        field.readOnlyOnEdit = false;
        templateManager.updateTemplate();

    };
    
    this.setValueOnClick = function(field, widget){
        var valorTecla = field.valueField;

        this.valor +=valorTecla; 
        this.disableButton(field);
        this.atualizaDisplay(this.valor, widget, field);
        
        

    };
    

    this.backSpaceOnClick = function(field, widget){

        this.valor = this.valor.slice(0,-1);
        this.atualizaDisplay(this.valor, widget, field);
    };
    
    this.deleteOnClick = function(widget, field){
        ScreenService.confirmMessage(ScreenService.i18n('Deseja excluir toda  a fórmula?'), 'question', function (success) {
            this.valor = '';
            this.atualizaDisplay(this.valor, widget, field);
        }.bind(this));
    };

}; 

Configuration(function(ContextRegister){
    ContextRegister.register('ped05900_composicao_preco_produto_Controller', ped05900_composicao_preco_produto_Controller);
});                                                          